/* Forbidden planet. Spectrum source... (Needs Zeus >= v2.11 to assemble)

This code is (c) 1985..2012 Simon Brattel. All rights reserved, etc, etc, yada yada ya.

Policy - to make the generated code as close as possible to the original release code,
but this version of the source code might well use features of the PC Zeus assembler that
were not present in the original development tools. Think of this as testing/examples.

Therefore this source contains the original anti-piracy code, make sure the top bit
of R is set. Or better yet, remove the test code (it is optional).

This source is now zeus specific. Zeus is free and the latest version can be downloaded
from http://www.desdes.com/products/oldfiles/zeus.exe

Feel free to improve the game, and send me anything interesting -> crem@desdes.com
*/

; Assembly time options. Comment these out to make them ineffective

                        zeusemulate "48K"

;Original        equ true                        ; Do the original (Strictly the original code)

;bAnalogDefault          equ not enabled Original        ; If enabled use the analog joystick

;bFreeVersion    equ not enabled Original        ; If enabled this is the free version

UseMacros               equ not enabled Original        ; Use macros
;Elephants       equ not enabled Original        ; Elephants or Krell meters?

RandomHS                equ true                        ; Random highscores

No_Check                equ not enabled Original        ; Don't test for piracy <grin>

bFrameLock              equ not enabled Original        ; We lock to the video frame

bCompressForTape        equ true                        ; Compress the data for loaders

; Change this to point somewhere suitable on your computer.
; Note that Windows 7 doesn't let you write into the root directory!

OutputDir               equ "c:\projects\games\fp\bin"  ; This needs to exist

//                      Include the equates

                        include "fp_equ.asm"

; Start of Spectrum free memory

                        org $5B00

                        ; Include the fixed data and the start vector

                        include "fp_data.asm"

                        org $6B00                       ; Start of code

; This looks like the start address, but that's a piece of misdirection.
; If you start it here it will crash (top bit of R is not set)...

Start                   jp Reset                        ;

; Vector to the actual game code

Play                    jp GameCode                     ;

;  Vectors to key scan code

kLeft                   defs 3                          ;

kRight                  defs 3                          ;

kUp                     defs 3                          ;

kDown                   defs 3                          ;

kAccel                  defs 3                          ;

kDeccel                 defs 3                          ;

kFire                   defs 3                          ;

                        defs 9,$00                      ; Spare room

vReadKey                jp ReadKeys                     ;

vScanOptiKeys           jp ScanOptiKeys                 ;

vPrint                  jp Print                        ;

vPrintStr               jp PrintStr                     ;

vAddScroll              jp AddScroll                    ;

pCurX                   defs 1                          ;
pCurY                   defs 2                          ;
ppCurY                  defs 1                          ;

AType                   defs 1                          ;
BType                   defs 1                          ;
CType                   defs 1                          ;
DType                   defs 1                          ;
EType                   defs 1                          ;

DDamage                 defs 1                          ;
ADamage                 defs 1                          ;

DScore                  defs 2                          ;

nCodesFound             defs 1                          ;

vFuckUp                 jp FuckUp                       ;

EndState                defs 1                          ;

Mode                    defs 1                          ;

; Character set for the soft-scrolling digits. The memory layout here is significant, don't separate these...

ScBase                  dg --####--                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg --#####-                     ;
                        dg -----##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg --------                     ;

Sc0                     dg --####--                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg --------                     ;

Sc1                     dg ---##---                     ;
                        dg --###---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg -######-                     ;
                        dg --------                     ;

Sc2                     dg --####--                     ;
                        dg -##--##-                     ;
                        dg -----##-                     ;
                        dg --####--                     ;
                        dg -##-----                     ;
                        dg -##--##-                     ;
                        dg -######-                     ;
                        dg --------                     ;

Sc3                     dg --####--                     ;
                        dg -##--##-                     ;
                        dg -----##-                     ;
                        dg ---###--                     ;
                        dg -----##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg --------                     ;

Sc4                     dg ---###--                     ;
                        dg --####--                     ;
                        dg -##-##--                     ;
                        dg ##--##--                     ;
                        dg #######-                     ;
                        dg ----##--                     ;
                        dg ---####-                     ;
                        dg --------                     ;

Sc5                     dg -######-                     ;
                        dg -##---#-                     ;
                        dg -##-----                     ;
                        dg -#####--                     ;
                        dg -----##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg --------                     ;

Sc6                     dg --####--                     ;
                        dg -##--##-                     ;
                        dg -##-----                     ;
                        dg -#####--                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg --------                     ;

Sc7                     dg -######-                     ;
                        dg -##--##-                     ;
                        dg -----##-                     ;
                        dg ----##--                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg --------                     ;

Sc8                     dg --####--                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg --------                     ;

Sc9                     dg --####--                     ;
                        dg -##--##-                     ;
                        dg -##--##-                     ;
                        dg --#####-                     ;
                        dg -----##-                     ;
                        dg -##--##-                     ;
                        dg --####--                     ;
                        dg --------                     ;

ScS                     dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg ---#----                     ;
                        dg --##----                     ;
                        dg ---#----                     ;
                        dg ---#----                     ;
                        dg ---#----                     ;
                        dg ---#----                     ;
                        dg --###---                     ;
                        dg --------                     ;

; Pointers to the digit graphics

ScTab1                  defw ScS,Sc1,Sc2,Sc3,Sc4        ;
                        defw Sc5,Sc6,Sc7,Sc8,Sc9        ;

ScTab2                  defw Sc0,Sc1,Sc2,Sc3,Sc4        ;
                        defw Sc5,Sc6,Sc7,Sc8,Sc9        ;

; Energy display dials

nDials                  equ 8                           ;

MaxEnergy               equ nDials*9-1                  ;

        if not enabled Elephants

; These are the Krell style graphics

Dial0                   dg -----######-----
                        dg ---##------##---
                        dg --#----------#--
                        dg -#------------#-
                        dg -#------------#-
                        dg #--------------#
                        dg #--------------#
                        dg #------##------#
                        dg #------##------#
                        dg #-----#--#-----#
                        dg #-----#--#-----#
                        dg -#---#----#---#-
                        dg -#---#----#---#-
                        dg --#--#----#--#--
                        dg ---##------##---
                        dg ----------------

Dial1                   dg -----######-----
                        dg ---##------##---
                        dg --#----------#--
                        dg -#------------#-
                        dg -#------------#-
                        dg #--------------#
                        dg #--------------#
                        dg #------##------#
                        dg #-----###------#
                        dg #----##--#-----#
                        dg #---###--#-----#
                        dg -#-###----#---#-
                        dg -#####----#---#-
                        dg --####----#--#--
                        dg ---##------##---
                        dg ----------------

Dial2                   dg -----######-----
                        dg ---##------##---
                        dg --#----------#--
                        dg -#------------#-
                        dg -#------------#-
                        dg #--------------#
                        dg #--------------#
                        dg #########------#
                        dg #########------#
                        dg #######--#-----#
                        dg #######--#-----#
                        dg -#####----#---#-
                        dg -#####----#---#-
                        dg --####----#--#--
                        dg ---##------##---
                        dg ----------------

Dial3                   dg -----######-----
                        dg ---##------##---
                        dg --##---------#--
                        dg -####---------#-
                        dg -#####--------#-
                        dg #######--------#
                        dg ########-------#
                        dg #########------#
                        dg #########------#
                        dg #######--#-----#
                        dg #######--#-----#
                        dg -#####----#---#-
                        dg -#####----#---#-
                        dg --####----#--#--
                        dg ---##------##---
                        dg ----------------

Dial4                   dg -----######-----
                        dg ---#####---##---
                        dg --######-----#--
                        dg -#######------#-
                        dg -#######------#-
                        dg ########-------#
                        dg ########-------#
                        dg #########------#
                        dg #########------#
                        dg #######--#-----#
                        dg #######--#-----#
                        dg -#####----#---#-
                        dg -#####----#---#-
                        dg --####----#--#--
                        dg ---##------##---
                        dg ----------------

Dial5                   dg -----######-----
                        dg ---##########---
                        dg --############--
                        dg -###########--#-
                        dg -##########---#-
                        dg ##########-----#
                        dg #########------#
                        dg #########------#
                        dg #########------#
                        dg #######--#-----#
                        dg #######--#-----#
                        dg -#####----#---#-
                        dg -#####----#---#-
                        dg --####----#--#--
                        dg ---##------##---
                        dg ----------------

Dial6                   dg -----######-----
                        dg ---##########---
                        dg --############--
                        dg -##############-
                        dg -##############-
                        dg ################
                        dg ################
                        dg #########------#
                        dg #########------#
                        dg #######--#-----#
                        dg #######--#-----#
                        dg -#####----#---#-
                        dg -#####----#---#-
                        dg --####----#--#--
                        dg ---##------##---
                        dg ----------------

Dial7                   dg -----######-----
                        dg ---##########---
                        dg --############--
                        dg -##############-
                        dg -##############-
                        dg ################
                        dg ################
                        dg ################
                        dg ################
                        dg #######--#-#####
                        dg #######--#---###
                        dg -#####----#---#-
                        dg -#####----#---#-
                        dg --####----#--#--
                        dg ---##------##---
                        dg ----------------

Dial8                   dg -----######-----
                        dg ---##########---
                        dg --############--
                        dg -##############-
                        dg -##############-
                        dg ################
                        dg ################
                        dg ################
                        dg ################
                        dg #######--#######
                        dg #######--#######
                        dg -#####----#####-
                        dg -#####----#####-
                        dg --####----####--
                        dg ---##------##---
                        dg ----------------

        else

; The elephant style gauges

Dial0                   dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------
                        dg ----------------

Dial1                   dg ----------------
                        dg ----------------
                        dg -##---------##--
                        dg #--#-------#--#-
                        dg -#---#-#-#---#--
                        dg -#----###----#--
                        dg #-------------#-
                        dg #--#-------#--#-
                        dg ##--#-----#--##-
                        dg #--#-------#--#-
                        dg --#---------#---
                        dg --#----##---#---
                        dg --#--##-##--#---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

Dial2                   dg ----------------
                        dg ----------------
                        dg -##---------##--
                        dg #--#--#----#--#-
                        dg -#---#-#-#---#--
                        dg -#----###----#--
                        dg #-------------#-
                        dg #--#-------#--#-
                        dg ##--#-----#--##-
                        dg #--#-------#--#-
                        dg --#---------#---
                        dg --###-#######---
                        dg --#####-#####---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

Dial3                   dg ----------------
                        dg ----------------
                        dg -##---#-----##--
                        dg #--#---#---#--#-
                        dg -#---#-#-#---#--
                        dg -#----###----#--
                        dg #-------------#-
                        dg #--#-------#--#-
                        dg ##--#-----#--##-
                        dg #--###---###--#-
                        dg --####--#####---
                        dg --###-#######---
                        dg --#####-#####---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

Dial4                   dg ----------------
                        dg ----------------
                        dg -##----#----##--
                        dg #--#---#---#--#-
                        dg -#---#-#-#---#--
                        dg -#----###----#--
                        dg #-------------#-
                        dg #--#-------#--#-
                        dg ##--#######--##-
                        dg #--#########--#-
                        dg --####--#####---
                        dg --###-#######---
                        dg --#####-#####---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

Dial5                   dg ----------------
                        dg ------#---------
                        dg -##----#----##--
                        dg #--#---#---#--#-
                        dg -#---#-#-#---#--
                        dg -#----###----#--
                        dg ##-----------##-
                        dg ###############-
                        dg ##--#######--##-
                        dg #--#########--#-
                        dg --####--#####---
                        dg --###-#######---
                        dg --#####-#####---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

Dial6                   dg ----------------
                        dg -------#--------
                        dg -##----#----##--
                        dg #--#---#---#--#-
                        dg -#---#-#-#---#--
                        dg -#----###----#--
                        dg ###############-
                        dg ###############-
                        dg ##--#######--##-
                        dg #--#########--#-
                        dg --####--#####---
                        dg --###-#######---
                        dg --#####-#####---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

Dial7                   dg ------#---------
                        dg -------#--------
                        dg -##----#----##--
                        dg #--#---#---#--#-
                        dg -##--#-#-#--##--
                        dg -#############--
                        dg ###############-
                        dg ###############-
                        dg ##--#######--##-
                        dg #--#########--#-
                        dg --####--#####---
                        dg --###-#######---
                        dg --#####-#####---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

Dial8                   dg -------#--------
                        dg -------#--------
                        dg -##----#----##--
                        dg ####---#---####-
                        dg -#####-#-#####--
                        dg -#############--
                        dg ###############-
                        dg ###############-
                        dg ##--#######--##-
                        dg #--#########--#-
                        dg --####--#####---
                        dg --###-#######---
                        dg --#####-#####---
                        dg --####---####---
                        dg --####---####---
                        dg --####---####---

        endif

pUDKTab                 defs 2                          ;
pKeyTab                 defs 2                          ;
pKeyVDU                 defs 2                          ;
CurType                 defs 1                          ;
FlashpDisp              defs 2                          ;
UDKat0                  defs 1                          ;
UDKat1                  defs 1                          ;

LineBuffer              defs 30                         ;

OptiFlashR              equ 400                         ;
JoyFlashRate            equ 400                         ;

CurFlag                 defs 1                          ;
CurrKey                 defs 1                          ;
CurrKeyAddr             defs 2                          ;

RepDel                  defs 2                          ;
RepSpeed1               defs 2                          ;
RepSpeed2               defs 2                          ;

CursorSpeed             defs 1                          ;
CursorType              defs 1                          ;
CurCol                  defs 1                          ;

CapsShift               equ KeyCounts                   ;
KeyCounts               defs 36                         ;
SymbolShift             defs 4                          ;

MinScans                equ 9                           ;
FlashRate               equ 130                         ;
HSTimeOut               equ $5400                       ;

pUDKd                   defs 1                          ;
UDKfr                   equ 400                         ;
UDKft                   defs 1                          ;
UDKatt                  defs 2                          ;

pList                   defs 2                          ;

EntryF                  defs 1                          ;
EntryY                  defs 2                          ;
pInsert                 defs 2                          ;
pHSEnd                  defs 2                          ;

KeyMask                 defs 40                         ;

        if enabled bAnalogDefault
cJoy                    defb 4                          ;
cJoyAttr                defs 2                          ;
cInput                  defb "J"                        ;
        else
cJoy                    defb 0                          ;
cJoyAttr                defs 2                          ;
cInput                  defb "K"                        ;
        endif

lKey                    equ 10                          ;

cDel                    equ $08                         ;
cCret                   equ $0D                         ;
cCls                    equ $0C                         ;
Clr                     equ $1B                         ;
cHome                   equ $0E                         ;

cBlack                  equ $00                         ;
cBlue                   equ $01                         ;
cRed                    equ $02                         ;
cMagenta                equ $03                         ;
cGreen                  equ $04                         ;
cCyan                   equ $05                         ;
cYellow                 equ $06                         ;
cWhite                  equ $07                         ;

Colon1R                 equ $5AC2                       ;
Colon2R                 equ $5AC5                       ;
Colon1N                 equ $580E                       ;
Colon2N                 equ $5811                       ;

ClockDataR              defw ScS,ScS,ScS,ScS,ScS,ScS            ;
                        defw $50C7,$50C6,$50C4,$50C3,$50C1,$50C0;
                        defb 9,5,9,5,9,9                        ;

ClockDataN              defw ScS,ScS,ScS,ScS,ScS,ScS            ;
                        defw $4013,$4012,$4010,$400F,$400D,$400C;
                        defb 9,5,9,5,9,9                        ;

CDEnd                   equ $                           ;

SecCount                defb 1                          ;

Slice                   defb 1                          ;

nScroll                 defb 1                          ;

p1                      defs 12                         ;

FirstpDig               defs 12                         ;
FirstDig                defs 6                          ;

ScCnt                   defb 0                          ;

Sc_F                    defb 0                          ;

ScPtr                   defw 0                          ;

ScAttr                  defb $45                        ;

ScACnt                  defb 0                          ;

Buff0                   defb 0                          ;
Buff1                   defb 0                          ;
Buff2                   defb 0                          ;
Buff3                   defb 0                          ;
Buff4                   defb 0                          ;
Buff5                   defb 0                          ;
Buff6                   defb 0                          ;
Buff7                   defb 0                          ;

pcDial                  defs 2                          ;

pcShape                 defs 2                          ;

Print                   push ix                         ;
                        push hl                         ;
                        push de                         ;
                        push bc                         ;
                        push af                         ;

                        cp cWhite+1                     ;
                        jr c,pColour                    ;

                        cp cCls                         ;
                        jr z,pCls                       ;

                        cp cCret                        ;
                        jr z,pCR                        ;

                        cp cHome                        ;
                        jr z,pHome                      ;

                        ld h,wChars/256                 ;
                        ld l,a                          ;

                        ld a,(pCurX)                    ;
                        add a,(hl)                      ;
                        call c,pCret                    ;

                        call pOutChar                   ;

                        ld a,(pCurX)                    ;
                        add a,(hl)                      ;
                        ld (pCurX),a                    ;

pExit                   pop af                          ;
                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        pop ix                          ;
                        ret                             ;

pColour                 cp 4                            ;
                        jr nc,pCol1                     ;

                        or $40                          ;

pCol1                   ld (CurCol),a                   ;
                        jr pExit                        ;

pCR                     call pCret                      ;
                        jr pExit                        ;

pCls                    ld e,$00                        ;
                        ld hl,Attrs                     ;
                        ld bc,$0300                     ;

pC1                     ld a,(hl)                       ;
                        and $07                         ;
                        jr z,pC2                        ;

                        set 0,e                         ;
                        dec (hl)                        ;
pC2                     cpi                             ;
                        jp pe,pC1                       ;

                        call Delay                      ;

                        bit 0,e                         ;
                        jr nz,pCls                      ;

                        ld hl,ScreenBase                ;
                        ld de,ScreenBase+1              ;
                        ld bc,$1800                     ;

                        xor a                           ;
                        ld (hl),a                       ;

                        ldir                            ;

                        ld a,(CurCol)                   ;
                        ld (hl),a                       ;

                        ld bc,$02FF                     ;

                        ldir                            ;

                        xor a                           ;
                        out ($FE),a                     ;

pHome                   xor a                           ;
                        ld (pCurX),a                    ;
                        ld (ppCurY),a                   ;

                        ld a,cWhite                     ;
                        ld (CurCol),a                   ;

                        ld hl,ScreenBase                ;
                        ld (pCurY),hl                   ;

                        jr pExit                        ;

pCret                   ld a,(ppCurY)                   ;
                        inc a                           ;

SetUpY                  ld (ppCurY),a                   ;

                        and $1F                         ;

                        push hl                         ;

                        ld l,a                          ;
                        ld h,$00                        ;

                        add hl,hl                       ;

                        ld de,YTableFE                  ;
                        add hl,de                       ;

                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld h,(hl)                       ;
                        ld l,a                          ;

                        ld (pCurY),hl                   ;

                        xor a                           ;
                        ld (pCurX),a                    ;

                        pop hl                          ;
                        ret                             ;

pOutChar                bit 7,l                         ;
                        ret nz                          ;

                        push hl                         ;

                        ld h,0                          ;

                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;

                        ld de,pChars-256                ;
                        add hl,de                       ;

                        push hl                         ;
                        pop ix                          ;

                        ld a,(pCurX)                    ;

                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        and $1F                         ;

                        ld de,(pCurY)                   ;

                        or e                            ;
                        ld e,a                          ;

                        push de                         ;

                        ld a,d                          ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        and $03                         ;
                        or $58                          ;
                        ld d,a                          ;

                        ld a,(CurCol)                   ;
                        ld (de),a                       ;
                        inc de                          ;
                        ld (de),a                       ;

                        pop de                          ;

                        ld a,(pCurX)                    ;
                        and $07                         ;
                        ld c,a                          ;

                        ld b,$08                        ;

OutCharL                ld h,(ix)                       ;
                        ld l,$00                        ;

                        ld a,c                          ;
                        or a                            ;
                        jr z,OCL1                       ;

OCL2                    srl h                           ;
                        rr l                            ;
                        dec a                           ;
                        jr nz,OCL2                      ;

OCL1                    ld a,(de)                       ;
                        xor h                           ;
                        ld (de),a                       ;

                        inc e                           ;

                        ld a,(de)                       ;
                        xor l                           ;
                        ld (de),a                       ;

                        dec e                           ;

                        inc ix                          ;
                        inc d                           ;

                        djnz OutCharL                   ;

                        pop hl                          ;
                        ret                             ;

YTableFE                defw $4000,$4020,$4040,$4060    ;
                        defw $4080,$40A0,$40C0,$40E0    ;
                        defw $4800,$4820,$4840,$4860    ;
                        defw $4880,$48A0,$48C0,$48E0    ;
                        defw $5000,$5020,$5040,$5060    ;
                        defw $5080,$50A0,$50C0,$50E0    ;
                        defw 0,0,0,0,0,0,0,0            ;

Wait                    ld a,$7F                        ;
                        in a,($FE)                      ;
                        rra                             ;
                        jr nc,Wait                      ;
                        ret                             ;

Delay                   push bc                         ;
                        ld bc,$0320                     ;
Del1                    cpi                             ;
                        dec hl                          ;
                        jp pe,Del1                      ;
                        pop bc                          ;
                        ret                             ;

PrintStr                push hl                         ;
                        push af                         ;
PStr1                   ld a,(hl)                       ;
                        inc hl                          ;
                        or a                            ;
                        jr z,PStr2                      ;
                        call Print                      ;
                        jr PStr1                        ;

PStr2                   pop af                          ;
                        pop hl                          ;
                        ret                             ;

PrintStr1               ex (sp),hl                      ;
                        push af                         ;
PStr11                  ld a,(hl)                       ;
                        inc hl                          ;
                        or a                            ;
                        jr z,PStr12                     ;
                        call Print                      ;
                        jr PStr11                       ;

PStr12                  pop af                          ;
                        ex (sp),hl                      ;
                        ret                             ;

InitKbd                 ld hl,KeyCounts                 ;
                        ld de,KeyCounts+1               ;
                        ld bc,$0027                     ;
                        ld (hl),$49                     ;
                        ldir                            ;

                        xor a                           ;
                        ld (CurrKey),a                  ;

                        ld hl,200                       ;
                        ld (RepSpeed1),hl               ;

                        ld hl,30                        ;
                        ld (RepSpeed2),hl               ;
                        ret                             ;

ReadKey                 push ix                         ;
                        push hl                         ;
                        push de                         ;
                        push bc                         ;
                        push af                         ;

                        ex af,af'                       ;
                        push af                         ;

                        ld hl,CapsShift                 ;
                        set 7,(hl)                      ;

                        ld hl,SymbolShift               ;
                        set 7,(hl)                      ;

                        call ReadKeys                   ;

                        dec a                           ;
                        ld b,a                          ;

                        xor a                           ;

                        ld hl,CapsShift                 ;
                        bit 6,(hl)                      ;
                        jr z,Shifta                     ;

                        add a,40                        ;

Shifta                  ld hl,SymbolShift               ;
                        bit 6,(hl)                      ;
                        jr z,Shiftb                     ;

                        add a,80                        ;

Shiftb                  add a,b                         ;

                        ld e,a                          ;
                        ld d,0                          ;

                        ld hl,kTab0                     ;
                        add hl,de                       ;

                        pop af                          ;
                        ex af,af'                       ;

                        pop af                          ;

                        ld a,(hl)                       ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        pop ix                          ;
                        ret                             ;

ReadKeys                ld a,1                          ;
                        ld (CursorSpeed),a              ;
                        ld (CursorType),a               ;

ReadKeyLp               call CursorInv                  ;

                        call ScanKeys                   ;

                        jr nz,RKNewKey                  ;

                        ld a,(CurrKey)                  ;
                        or a                            ;
                        jr z,ReadKeyLp                  ;

                        ld hl,(CurrKeyAddr)             ;
                        bit 6,(hl)                      ;
                        jr z,RKCancelOld                ;

                        ld hl,(RepDel)                  ;
                        dec hl                          ;
                        ld (RepDel),hl                  ;

                        ld a,l                          ;
                        or h                            ;
                        jr nz,ReadKeyLp                 ;

                        ld hl,(RepSpeed2)               ;
RK1                     ld (RepDel),hl                  ;

                        call CursorOff                  ;

                        ld a,(CurrKey)                  ;
                        ret                             ;

RKNewKey                ld (CurrKey),a                  ;

                        ld hl,(RepSpeed1)               ;
                        ld (CurrKeyAddr),ix             ;

                        jr RK1                          ;

RKCancelOld             xor a                           ;
                        ld (CurrKey),a                  ;

                        jr ReadKeyLp                    ;

CursorOff               ld a,(CursorType)               ;
                        or a                            ;
                        jr z,FlipCur                    ;
                        ret                             ;

CursorInv               ld a,(CursorSpeed)              ;
                        dec a                           ;
                        ld (CursorSpeed),a              ;
                        ret nz                          ;

                        ld a,FlashRate                  ;
                        ld (CursorSpeed),a              ;

                        ld a,(CursorType)               ;
                        xor $01                         ;
                        ld (CursorType),a               ;

FlipCur                 ld l,$5F                        ;

                        jp pOutChar                     ;

ScanKeys                ld bc,$FFFE                     ;
                        ld hl,KeyCounts                 ;
                        ld e,0                          ;

ScanKeyLp               dec b                           ;
                        in a,(c)                        ;

                        ld d,5                          ;

ScanKeyLp2              rra                             ;
                        call nc,SKPressed               ;
                        call c,SKNotPressed             ;
                        inc hl                          ;

                        dec d                           ;
                        jr nz,ScanKeyLp2                ;

                        scf                             ;
                        rl b                            ;
                        inc b                           ;
                        jr nz,ScanKeyLp                 ;

                        ld a,e                          ;
                        or a                            ;
                        ret                             ;

SKPressed               ex af,af'                       ;

                        ld a,(hl)                       ;
                        and $3F                         ;
                        cp MinScans                     ;
                        jr z,SKP1                       ;

                        inc (hl)                        ;

                        ex af,af'                       ;
                        ret                             ;

SKP1                    bit 6,(hl)                      ;
                        jr nz,SKexit                    ;

                        bit 7,(hl)                      ;
                        jr nz,SKexit1                   ;

                        ld a,e                          ;
                        or a                            ;
                        jr nz,SKexit                    ;

                        push hl                         ;
                        pop ix                          ;

                        call CalcKeyPos                 ;

                        ld e,a                          ;

SKexit1                 set 6,(hl)                      ;

SKexit                  ex af,af'                       ;
                        ret                             ;

SKNotPressed            ex af,af'                       ;

                        ld a,(hl)                       ;
                        and $3F                         ;
                        jr z,SKNP1                      ;

                        dec (hl)                        ;

                        ex af,af'                       ;
                        ret                             ;

SKNP1                   res 6,(hl)                      ;

                        ex af,af'                       ;
                        ret                             ;

CalcKeyPos              push de                         ;

                        ld de,KeyCounts-1               ;
                        or a                            ;
                        sbc hl,de                       ;

                        ld a,l                          ;

                        add hl,de                       ;

                        pop de                          ;
                        ret                             ;

; Keyboard map

kTab0                   defb " zxcv"                    ;
                        defb "asdfg"                    ;
                        defb "qwert"                    ;
                        defb "12345"                    ;
                        defb "09876"                    ;
                        defb "poiuy"                    ;
                        defb cCret,"lkjh"               ;
                        defb "  mnb"                    ;

                        defb " ZXCV"                    ;
                        defb "ASDFG"                    ;
                        defb "QWERT"                    ;
                        defb "!@#$%"                    ;
                        defb cDel,")('&"                ;
                        defb "POIUY"                    ;
                        defb cCret,"LKJH"               ;
                        defb "  MNB"                    ;

                        defb " :#?/"                    ;
                        defb "~|'{}"                    ;
                        defb "   <>"                    ;
                        defb "!@#$%"                    ;
                        defb "_)('&"                    ;
                        defb $22,"; ]["                 ;
                        defb cCret,"=+-^"               ;
                        defb "  .,*"                    ;

                        ; Note that the hidden message in the keys was corrupted

                        defb "     "                    ;
                        defb "t I g"                    ; This should present a message if you hit the
                        defb "a gir"                    ; extended-shift keys in order...
                        defb cBlue,cRed,cMagenta,cGreen,cCyan ;
                        defb Clr,cCls,cCret,cWhite,cYellow;
                        defb "sel l"                    ;
                        defb "dam o"                    ;
                        defb "     "                    ;

; Front end code starts here

Reset                   di                              ;

                        ld a,r                          ; Randomly choose a table
                        and $06                         ; (if the loader doesn't screw R)

                        add a,HighPtrs & $FF            ;
                        ld l,a                          ;
                        ld h, HighPtrs / 256            ;

                        ld a,(hl)                       ; Read the address
                        inc hl                          ;
                        ld h,(hl)                       ;
                        ld l,a                          ;

                        ld de,HighScores                ; And move it to the start
                        ld bc,$0300                     ;
                        ldir                            ;

        if enabled Original
Boot                    ld sp,$0000                     ; Set the stack
        else
Boot                    ld sp,ScoreReportAddr           ; Set the stack
        endif

                        ld hl,iUDKTab                   ; Set the user defined keys
                        ld de,UDKTab                    ;
                        ld bc,$0080                     ;
                        ldir                            ;

                        call InitKbd                    ; Setup the keys

                        call InitOpti                   ; And the options

DispMain                di                              ; Start the front end

                        ld hl,sMainMenu                 ; Show the menu
                        call PrintStr                   ;

                        ld hl,HSTimeOut                 ; Pause before show highscores

MainLoop                ld bc,$7C10                     ;
                        call ScanOptiKeys               ;

                        ld de,MainVecTab                ;
                        jp c,VecGoto                    ;

                        dec hl                          ; Loop
                        ld a,h                          ;
                        or l                            ;
                        jr nz,MainLoop                  ;

                        ; Show the highscore table

DispHS                  ld hl,0                         ;
                        ld (DScore),hl                  ;

DispHS1                 xor a                           ;
                        ld (EntryF),a                   ;

                        ld hl,sHighA                    ;
                        call PrintStr                   ;

                        ld ix,HighScores                ;
                        ld a,"1"                        ;
DHSlp                   call PrintHS                    ;

                        inc a                           ;
                        cp "9"+1                        ;
                        jr nz,DHS1                      ;

                        add a,"A"-("9"+1)               ;

DHS1                    cp "H"                          ;
                        jr nz,DHSlp                     ;

                        ld a,(EntryF)                   ;
                        or a                            ;
                        jp nz,AcceptEnt                 ;

                        ld hl,sHighB                    ;
                        call PrintStr                   ;

HSw                     ld bc,$0030                     ;
                        call ScanOptiKeys               ;

                        jr nc,HSw                       ;

                        cp 10                           ;
                        jp z,DispMain                   ;

                        jp DispGame                     ;

DispCont                ld a,(cInput)                   ;
                        cp "J"                          ;
                        jp z,DispJoy                    ;

DispKeys                ld a,"K"                        ;
                        ld (cInput),a                   ;

                        ld hl,sKeysMenu                 ;
                        call PrintStr                   ;

                        ld hl,UDKTab                    ;
                        ld iy,YTableFE+4                ;
                        ld b,$07                        ;

UDKa                    push bc                         ;

                        ld c,(iy)                       ;
                        ld b,(iy+1)                     ;
                        ld (pCurY),bc                   ;

                        ld a,100                        ;
                        ld (pCurX),a                    ;

                        call UDKlist                    ;

                        ld bc,4                         ;
                        add iy,bc                       ;

                        ld a,l                          ;
                        or $0F                          ;
                        ld l,a                          ;

                        inc hl                          ;

                        pop bc                          ;

                        djnz UDKa                       ;

UDKw                    call UDKwa1                     ;

UDKw1                   ld bc,$7FF0                     ;
                        call ScanOptiKeys               ;
                        jr nc,UDKw1                     ;

                        cp 9                            ;
                        jp z,DispJoy                    ;

                        cp 8                            ;
                        jp nc,DispMain                  ;

                        push af                         ;

                        add a,a                         ;

                        add a,a                         ;
                        ld l,a                          ;
                        ld h,0                          ;

                        ld de,YTableFE                  ;
                        add hl,de                       ;

                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld h,(hl)                       ;
                        ld l,a                          ;

                        ld (pCurY),hl                   ;

                        pop af                          ;

                        dec a                           ;
                        ld l,a                          ;
                        ld h,$00                        ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;

                        ld bc,Attrs+64+2                ;
                        add hl,bc                       ;

                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ;

                        ld e,a                          ;
                        ld d,0                          ;

                        inc hl                          ;
                        ld a,(hl)                       ;
                        ld (UDKat0),a                   ;
                        dec hl                          ;

                        xor $40                         ;

                        ld (UDKat1),a                   ;

                        ld (pKeyVDU),hl                 ;

                        ld hl,UDKTab                    ;
                        add hl,de                       ;
                        ld (pKeyTab),hl                 ;

                        ld a,100                        ;
                        ld (pCurX),a                    ;

                        ld iy,(pCurY)                   ;

                        ld hl,(pKeyTab)                 ;
                        call UDKlist                    ;

                        ld (pCurY),iy                   ;

                        ld a,100                        ;
                        ld (pCurX),a                    ;

                        ld hl,(pKeyTab)                 ;

                        ld b,$10                        ;
UDKc1                   ld (hl),$FF                     ;
                        inc hl                          ;
                        djnz UDKc1                      ;

                        call UDKwa1                     ;

                        call SetUpKeyMap                ;

                        ld ix,(pKeyTab)                 ;

                        xor a                           ;
                        ld (CurType),a                  ;

                        ld hl,1                         ;

UDKlp                   call FlashLine                  ;

                        call UDKscan                    ;
                        jr z,UDKlp                      ;

                        cp 16                           ; "1"
                        jr z,UDKend                     ;

                        dec a                           ;
                        ld b,a                          ;
                        ld a,ixl                        ;
                        cpl                             ;
                        and $0F                         ;
                        jr z,UDKlp                      ;

                        ld a,cMagenta                   ;
                        call Print                      ;

                        ld a,b                          ;
                        ld (ix),a                       ;
                        inc ix                          ;

                        call UDKchar                    ;

                        call PrintSp2                   ;

                        jr UDKlp                        ;

UDKwa1                  ld e,30                         ;

                        ld b,$7F                        ;

UDKwait                 ld c,$FE                        ;
                        in a,(c)                        ;
                        or $E0                          ;
                        inc a                           ;
                        jr nz,UDKwa1                    ;

                        rrc b                           ;
                        jr c,UDKwait                    ;

                        dec e                           ;
                        jr nz,UDKwait                   ;

                        ret                             ;

UDKend                  ld a,(UDKat0)                   ;
                        call FLO                        ;

                        push ix                         ;
                        pop hl                          ;

                        ld de,(pKeyTab)                 ;
                        or a                            ;
                        sbc hl,de                       ;
                        jp nz,UDKw                      ;

                        ld l,e                          ;
                        ld h,d                          ;

                        ld bc,iUDKTab-UDKTab            ;
                        add hl,bc                       ;

                        ld bc,16                        ;
                        ldir                            ;

                        ld hl,(pKeyTab)                 ;
                        call UDKlist                    ;

                        jp UDKw                         ;

UDKscan                 ld iy,KeyCounts                 ;
                        ld e,1                          ;
                        ld c,$FE                        ;

                        ld b,$FE                        ;

UDKsc1                  ld d,$01                        ;

UDKsc2                  in a,(c)                        ;
                        and d                           ;
                        jr nz,UDKsc3                    ;

                        bit 6,(iy)                      ;
                        jr z,UDKsc3                     ;

                        res 6,(iy)                      ;
                        ld a,e                          ;
                        ret                             ;

UDKsc3                  inc iy                          ;
                        inc e                           ;

                        rlc d                           ;
                        ld a,d                          ;
                        cp $20                          ;
                        jr nz,UDKsc2                    ;

                        rlc b                           ;
                        jr c,UDKsc1                     ;

                        xor a                           ;
                        ret                             ;

UDKlist                 ld a,(hl)                       ;
                        bit 7,(hl)                      ;
                        ret nz                          ;

                        ld a,cMagenta                   ;
                        call Print                      ;

                        ld a,(hl)                       ;
                        call UDKchar                    ;

                        call PrintSp2                   ;

                        ld a,l                          ;
                        cpl                             ;
                        and $0F                         ;
                        ret z                           ;

                        inc hl                          ;

                        jr UDKlist                      ;

; Show a UDK character name. Some are more than one char long...

UDKchar                 push hl                         ;

                        ld hl,UDKdesc                   ;
                        inc a                           ;
UDKp                    dec a                           ;
                        jr z,UDKp1                      ;

UDKp2                   bit 7,(hl)                      ;
                        inc hl                          ;
                        jr nz,UDKp2                     ;

                        jr UDKp                         ;

UDKp1                   ld a,(hl)                       ;
                        and $7F                         ;

                        call Print                      ;

                        bit 7,(hl)                      ;
                        inc hl                          ;
                        jr nz,UDKp1                     ;

                        pop hl                          ;
                        ret                             ;


SetUpKeyMap             ld hl,KeyCounts                 ;
                        ld b,40                         ;
SUKM                    set 6,(hl)                      ;
                        inc hl                          ;
                        djnz SUKM                       ;
                        ret                             ;

DispJoy                 ld a,"J"                        ;
                        ld (cInput),a                   ;

                        ld hl,sJoysticks                ;
                        call PrintStr                   ;

                        ld a,(cJoy)                     ;
NewJoy                  call CalcpJoyAttr               ;
                        ld (cJoyAttr),hl                ;

                        call GrabLine                   ;

                        ld d,0                          ;

                        ld hl,1                         ;

DJlp                    dec hl                          ;

                        ld a,l                          ;
                        or h                            ;
                        jr nz,DJa                       ;

                        ld hl,(cJoyAttr)                ;

                        inc d                           ;
                        bit 0,d                         ;

                        jr z,DJ1                        ;

                        call ClearLine                  ;

                        ld d,1                          ;

                        jr DJa1                         ;

DJ1                     call PutLine                    ;

                        ld d,0                          ;

DJa1                    ld hl,JoyFlashRate              ;

DJa                     ld bc,$7CF0                     ;
                        call ScanOptiKeys               ;
                        jr nc,DJlp                      ;

                        cp 9                            ;
                        jp z,DispKeys                   ;

                        cp 8                            ;
                        jp nc,DispMain                  ;

                        ld hl,(cJoyAttr)                ;
                        call PutLine                    ;

                        dec a                           ;

                        ld b,a                          ;
                        ld a,(cJoy)                     ;
                        cp b                            ;
                        jr z,NewJoy                     ;

                        ld a,b                          ;
                        ld (cJoy),a                     ;

                        jp NewJoy                       ;


CalcpJoyAttr            ld l,a                          ;
                        ld h,0                          ;

                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;

                        ld de,Attrs+(3*32)+2            ;
                        add hl,de                       ;

                        ret                             ;


InitOpti                ld ix,OptiData                  ;
                        ld hl,AType                     ;
                        ld b,nOptions                   ;
                        ld d,0                          ;

InitOptiLp              push ix                         ;

                        ld a,(ix+4)                     ;
                        add a,5                         ;
                        ld e,a                          ;

                        add ix,de                       ;

                        ld a,(ix)                       ;
                        ld (hl),a                       ;

                        inc hl                          ;

                        pop ix                          ;

                        ld e,16                         ;
                        add ix,de                       ;

                        djnz InitOptiLp                 ;

                        ret                             ;


GetString               ld ix,HSBuffer                  ;
                        call InitKbd                    ;

                        ld a,cMagenta                   ;
                        call Print                      ;

AElp                    call ReadKey                    ;

                        or a                            ;
                        jr z,AElp                       ;

                        cp cCret                        ;
                        ret z                           ;

                        cp cDel                         ;
                        jr z,AEDel                      ;

                        cp Clr                          ;
                        jr z,AEclr                      ;

                        cp 8                            ;
                        jr c,AE1                        ;

                        cp $18                          ;
                        jr c,AElp                       ;

AE1                     ld e,a                          ;
                        ld d,wChars/256                 ;
                        ld a,(de)                       ;
                        ld c,a                          ;

                        ld a,(pCurX)                    ;
                        add a,c                         ;
                        cp 255-39                       ;
                        jr nc,AElp                      ;

                        push ix                         ;
                        pop hl                          ;

                        ld bc,HSBuffer                  ;
                        or a                            ;
                        sbc hl,bc                       ;

                        ld bc,130                       ;
                        or a                            ;
                        sbc hl,bc                       ;
                        jr nc,AElp                      ;

                        ld a,e                          ;
                        ld (ix),a                       ;
                        inc ix                          ;
                        call Print                      ;
                        jr AElp                         ;

AEDel                   call AEcDel                     ;
                        jp AElp                         ;

AEclr                   call AEcDel                     ;
                        jr nz,AEclr                     ;

                        jp AElp                         ;

; Remove a character/colour code

AEcDel                  ld de,HSBuffer                  ;

                        push ix                         ;
                        pop hl                          ;

                        or a                            ;
                        sbc hl,de                       ;
                        add hl,de                       ;

                        ret z                           ;

                        dec hl                          ;
                        ld a,(hl)                       ;
                        cp 8                            ;
                        jr c,DelCC                      ;

                        push hl                         ;
                        ld l,a                          ;
                        ld b,a                          ;
                        ld h,wChars/256                 ;
                        ld e,(hl)                       ;
                        ld d,0                          ;
                        ld hl,(pCurX)                   ;
                        or a                            ;
                        sbc hl,de                       ;
                        ld (pCurX),hl                   ;
                        ld a,b                          ;
                        call Print                      ;
                        ld (pCurX),hl                   ;
                        pop ix                          ;
                        or a                            ;
                        ret                             ;

DelCC                   ld de,HSBuffer                  ;
                        ld c,cMagenta                   ;

DCC1                    or a                            ;
                        sbc hl,de                       ;
                        add hl,de                       ;
                        jr z,DCC2                       ;

                        ld a,(de)                       ;
                        cp 8                            ;
                        jr nc,DCC3                      ;
                        ld c,a                          ;

DCC3                    inc de                          ;
                        jr DCC1                         ;

DCC2                    ld a,c                          ;
                        call Print                      ;

                        push hl                         ;
                        pop ix                          ;

                        or a                            ;
                        ret                             ;

AcceptEnt               ld hl,sAccept                   ;
                        call PrintStr                   ;

                        ld hl,(EntryY)                  ;
                        ld (pCurY),hl                   ;

                        ld a,9                          ;
                        ld (pCurX),a                    ;

                        call GetString                  ;

                        push ix                         ;
                        pop hl                          ;
                        call MWEntry                    ;
                        ld (hl),0                       ;
                        inc hl                          ;
                        ld a,(DScore)                   ;
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld a,(DScore+1)                 ;
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld de,HSBuffer                  ;
                        or a                            ;
                        sbc hl,de                       ;
                        ld b,h                          ;
                        ld c,l                          ;
                        push bc                         ;
                        ld hl,(pHSEnd)                  ;
                        ld de,(pInsert)                 ;
                        or a                            ;
                        sbc hl,de                       ;
                        push hl                         ;
                        ld hl,(pHSEnd)                  ;
                        add hl,bc                       ;
                        ex de,hl                        ;
                        ld hl,(pHSEnd)                  ;
                        pop bc                          ;
                        inc bc                          ;
                        lddr                            ;
                        ld hl,HSBuffer                  ;
                        ld de,(pInsert)                 ;
                        pop bc                          ;
                        ldir                            ;

                        ; Now, report the score to the emulator

        if not enabled Original

                        ld hl,(DScore)                  ; Copy store
                        ld (ScoreReportAddr),hl         ; Store it

                        ld hl,ScoreReportVector         ;
                        ld (hl),$C9                     ; RET

                        call ScoreReportVector          ; And call the RET
        endif

                        ; Done

                        jp DispHS                       ;

MWEntry                 ld de,HSBuffer                  ; Is the entry blank?
                        or a                            ;
                        sbc hl,de                       ;
                        jr nz,MWE1                      ;

                        ; If so we change it to "Someone" for the first 8 tries
                        ; then to "Someone else" after 8 blank entries
                        ; then to "Someone else ( who shall remain nameless)" after 16

                        ld a,0                          ; Self-modifying code...
nSomeone                equ .-1                         ;
                        inc a                           ;
                        ld (nSomeone),a                 ;

                        cp 16                           ; > 16?
                        ld bc,SomeoneEnd-Someone        ;
                        jr nc,MWEa                      ;

                        cp Someone1 - Someone           ; < 8
                        ld bc,8                         ;
                        jr c,MWEa                       ;

                        ld bc,Someone2-Someone          ; 9..15

MWEa                    ld hl,Someone                   ;
                        ld de,HSBuffer                  ;
                        ldir                            ;
                        ex de,hl                        ;
                        ret                             ;

Someone                 defb "Someone"                          ;
Someone1                defb " else"                            ;
Someone2                defb " ( who shall remain nameless )***";
SomeoneEnd              equ $                                   ;

MWE1                    xor a                           ; Clear the someone count
                        ld (nSomeone),a                 ;

                        ld a,l                          ; Entry > 125 chars?
                        add hl,de                       ;
                        cp 125                          ;
                        jr c,MWE2                       ;

                        ; Replace with the long entry text

                        ld hl,TooLong                   ;
                        ld de,HSBuffer                  ;
                        ld bc,lTooLong                  ;
                        ldir                            ;
                        ex de,hl                        ;
                        ret                             ;

TooLong                 defb "What strange behaviour !" ;
lTooLong                equ .-TooLong                   ;

MWE2                    ld ix,sClues                    ;
                        ld iy,Text                      ;
                        ld (hl),0                       ;
                        push hl                         ;

MWElp                   push ix                         ;
                        ld hl,HSBuffer                  ;

Mlp1                    ld a,(hl)                       ;
                        or a                            ;
                        jr z,Mlpf                       ;

                        cp $21                          ;
                        inc hl                          ;
                        jr c,Mlp1                       ;

                        call ConvLC                     ;
                        cp (ix)                         ;
                        inc ix                          ;
                        jr z,Mlp1                       ;

                        dec ix                          ;

Mlpf                    ld a,(ix)                       ;
                        or a                            ;
                        pop ix                          ;
                        jr z,MWEcg                      ;

StepIX                  ld a,(ix)                       ;
                        inc ix                          ;
                        or a                            ;
                        jr nz,StepIX                    ;

StepIY                  ld a,(iy)                       ;
                        inc iy                          ;
                        or a                            ;
                        jr nz,StepIY                    ;

                        ld a,(ix)                       ;
                        inc a                           ;
                        jr nz,MWElp                     ;
                        pop hl                          ;
                        ret                             ;

ConvLC                  cp "Z"+1                        ;
                        ret nc                          ;
                        cp "A"                          ;
                        ret c                           ;
                        add a,"a"-"A"                   ;
                        ret                             ;

MWEcg                   push iy                         ;
                        pop de                          ;

                        pop af                          ;

                        ld hl,HSBuffer                  ;
CGlp                    ld a,(de)                       ;
                        or a                            ;
                        ret z                           ;

                        ld (hl),a                       ;
                        inc hl                          ;
                        inc de                          ;

                        jr CGlp                         ;

DispOpti                ld hl,sOptiMenu                 ;
                        call PrintStr                   ;

        if enabled bFreeVersion
OptiLoop                ld bc,$04A0                     ;
        else
OptiLoop                ld bc,$74A0                     ;
        endif
                        call ScanOptiKeys               ;
                        jr nc,OptiLoop                  ;

                        cp 5                            ;
                        jp z,HexMon                     ;

                        cp 8                            ;
                        jp z,DispMain                   ;
                        cp 10                           ;
                        jp z,DispMain                   ;

                        dec a                           ;
                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ;
                        ld e,a                          ;
                        ld d,0                          ;
                        ld ix,OptiData                  ;
                        add ix,de                       ;

                        ld l,(ix+2)                     ;
                        ld h,(ix+3)                     ;
                        call PrintStr                   ;

                        ld a,20                         ;
                        ld (ppCurY),a                   ;

                        ld hl,sBottom                   ;
                        call PrintStr                   ;

OptiLpA                 ld a,(ix+4)                     ;
                        call CalcpVDU                   ;
                        ld (FlashpDisp),hl              ;

                        call GrabLine                   ;

                        ld d,0                          ;

OptiLpB                 ld hl,OptiFlashR                ;

OptiLp1                 ld b,(ix+5)                     ;
                        ld c,$E0                        ;
                        call ScanOptiKeys               ;
                        jr c,OptiKP                     ;

                        dec hl                          ;
                        ld a,l                          ;
                        or h                            ;
                        jr nz,OptiLp1                   ;

                        ld a,d                          ;
                        cpl                             ;
                        ld d,a                          ;
                        or a                            ;

                        push de                         ;
                        ld hl,(FlashpDisp)              ;
                        push af                         ;
                        call z,PutLine                  ;
                        pop af                          ;
                        call nz,ClearLine               ;
                        pop de                          ;

                        jr OptiLpB                      ;

OptiKP                  cp (ix+4)                       ;
                        jr z,OptiLp1                    ;

                        push af                         ;
                        ld hl,(FlashpDisp)              ;
                        call PutLine                    ;
                        pop af                          ;

                        cp 8                            ;
                        jp z,DispMain                   ;
                        cp 9                            ;
                        jp nc,DispOpti                  ;

                        ld (ix+4),a                     ;

                        push ix                         ;
                        pop hl                          ;

                        add a,5                         ;

                        ld e,a                          ;
                        ld d,0                          ;

                        add hl,de                       ;

                        ld a,(hl)                       ;

                        ld l,(ix+11)                    ;
                        ld h,(ix+12)                    ;
                        ld (hl),a                       ;

                        jr OptiLpA                      ;

CalcpVDU                push de                         ;

                        dec a                           ;

                        ld l,a                          ;
                        ld h,0                          ;

                        add hl,hl                       ;

                        ld de,CpV                       ;
                        add hl,de                       ;

                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld h,(hl)                       ;
                        ld l,a                          ;

                        pop de                          ;
                        ret                             ;

CpV                     defw $5882,$58C2,$5942,$5982,$5A22

GrabLine                ld de,LineBuffer                ;
                        ld bc,30                        ;
                        ldir                            ;
                        ret                             ;

FlashLine               dec hl                          ;

                        ld a,h                          ;
                        or l                            ;
                        ret nz                          ;

                        ld hl,(pKeyVDU)                 ;

                        ld a,(CurType)                  ;
                        xor $01                         ;
                        ld (CurType),a                  ;

                        ld a,(UDKat0)                   ;

                        jr z,FLO                        ;

                        ld a,(UDKat1)                   ;

FLO                     ld hl,(pKeyVDU)                 ;

                        ld d,h                          ;
                        ld e,l                          ;
                        inc de                          ;

                        ld bc,7                         ;

                        ld (hl),a                       ;

                        ldir                            ;

                        ld hl,UDKfr                     ;
                        ret                             ;

PutLine                 ex de,hl                        ;
                        ld hl,LineBuffer                ;
                        ld bc,30                        ;
                        ldir                            ;
                        ret                             ;

ClearLine               ld e,l                          ;
                        ld d,h                          ;
                        inc de                          ;
                        ld (hl),$41                     ;
                        ld bc,29                        ;
                        ldir                            ;
                        ret                             ;

HexMon                  ld a,0                          ; Self modifying code
MonFlag                 equ .-1                         ;
                        or a                            ;
                        jr nz,HexMon1                   ;

                        ld hl,sHexMon                   ;
                        call PrintStr                   ;

                        call Input                      ;

                        call ReadHex16                  ;

                        ld de,$1278                     ;
                        or a                            ;
                        sbc hl,de                       ;
                        jp nz,DispOpti                  ;

                        ld a,1                          ;
                        ld (MonFlag),a                  ;

HexMon1                 ld hl,sHexMon1                  ;
                        call PrintStr                   ;

MonLoop                 call Input                      ;
                        ld a,(de)                       ;
                        inc de                          ;
                        or a                            ;
                        jr z,MonLoop                    ;

                        cp " "                          ;
                        jr z,MonLoop                    ;

                        cp "m"                          ;
                        jr z,MonM                       ;

                        cp "t"                          ;
                        jr z,MonT                       ;

                        cp "q"                          ;
                        jp z,DispOpti                   ;

                        cp "e"                          ;
                        jr nz,MonLoop                   ;

                        call ReadHex16                  ;
                        jr c,MonErr                     ;

                        call FrontCallHL                ;

                        jp MonLoop                      ;

MonM                    call ReadHex16                  ;
                        jp c,MonErr                     ;

MonMlp                  call ReadHex8                   ;
                        jr z,MonLoop                    ;
                        jp c,MonErr                     ;

                        ld (hl),a                       ;
                        inc hl                          ;

                        jr MonMlp                       ;

MonT                    call ReadHex16                  ;
                        jr z,MonTa                      ;
                        jp c,MonErr                     ;

                        ld (TabPtr),hl                  ;

MonTa                   call ClearWind                  ;

                        ld ix,$0000                     ; Self modifying code
TabPtr                  equ .-2                         ;

                        ld b,8                          ;

MonTlp                  push bc                         ;
                        call TabLine                    ;
                        pop bc                          ;

                        djnz MonTlp                     ;

                        ld (TabPtr),ix                  ;

                        jp MonLoop                      ;

TabLine                 push ix                         ;
                        pop hl                          ;

                        call PrintHex16                 ;

                        ld b,8                          ;

TLlp                    ld a," "                        ;
                        call Print                      ;

                        ld a,(ix)                       ;
                        inc ix                          ;

                        call PrintHex8                  ;

                        djnz TLlp                       ;

                        ld a,cCret                      ;
                        jp Print                        ;

ClearWind               ld hl,$4800                     ;

CW8                     push hl                         ;
                        call ClearGraph                 ;
                        pop hl                          ;

                        ld a,l                          ;
                        add a,$20                       ;
                        ld l,a                          ;
                        jr nz,CW8                       ;

                        ld a,7                          ;
                        ld (ppCurY),a                   ;

                        ld a,cCyan                      ;
                        call Print                      ;

                        ld a,cCret                      ;
                        jp Print                        ;

MonErr                  ld hl,$40C0                     ;
                        ld (pCurY),hl                   ;

                        xor a                           ;
                        ld (pCurX),a                    ;

                        ld hl,sMonError                 ;
                        call PrintStr                   ;

                        ld bc,0                         ;
Err_1                   cpi                             ;
                        jp pe,Err_1                     ;

                        ld hl,$40C0                     ;
                        call ClearGraph                 ;

                        jp MonLoop                      ;

ClearGraph              call CGa                        ;

                        inc h                           ;
                        ld a,h                          ;
                        and $07                         ;
                        ret z                           ;

                        jr ClearGraph                   ;

CGa                     push hl                         ;

                        ld d,h                          ;
                        ld e,l                          ;
                        inc de                          ;
                        ld bc,$001F                     ;

                        ld (hl),$00                     ;

                        ldir                            ;

                        pop hl                          ;
                        ret                             ;

Input                   ld hl,$4080                     ;
                        ld (pCurY),hl                   ;

                        call ClearGraph                 ;

                        xor a                           ;
                        ld (pCurX),a                    ;

                        call GetString                  ;
                        ld (ix),$00                     ;
                        ld de,HSBuffer                  ;
                        ret                             ;

Hex                     sub "0"                         ;
                        ret c                           ;
                        cp 10                           ;
                        ccf                             ;
                        ret nc                          ;
                        sub 7+" "                       ;
                        cp 10                           ;
                        ret c                           ;
                        cp 17                           ;
                        ccf                             ;
                        ret                             ;

ReadHex8                push hl                         ;
                        call ReadHex16                  ;
                        push af                         ;
                        ld a,h                          ;
                        or a                            ;
                        jr z,RH8                        ;
                        pop af                          ;
                        scf                             ;
                        ld a,l                          ;
                        pop hl                          ;
                        ret                             ;

RH8                     pop af                          ;
                        ld a,l                          ;
                        pop hl                          ;
                        ret                             ;

ReadHex16               ld a,(de)                       ;
                        inc de                          ;

                        cp " "                          ;
                        jr z,ReadHex16                  ;

                        dec de                          ;

ReadHex                 ld a,(de)                       ;
                        or a                            ;
                        scf                             ;
                        ret z                           ;

                        call Hex                        ;
                        ret c                           ;

                        ld h,0                          ;
                        ld l,a                          ;

Read3                   inc de                          ;
                        ld a,(de)                       ;

                        call Hex                        ;
                        ccf                             ;
                        ret nc                          ;

                        add hl,hl                       ;
                        ret c                           ;
                        add hl,hl                       ;
                        ret c                           ;
                        add hl,hl                       ;
                        ret c                           ;
                        add hl,hl                       ;
                        ret c                           ;
                        or l                            ;
                        ld l,a                          ;

                        jr Read3                        ;

Mon                     call ReadKey                    ;
                        call Print                      ;

DispDemo                ld a,1                          ;
                        jp DispGame1                    ;

DispInst                ld hl,sInst                     ;
                        call PrintStr                   ;

DIlp                    ld bc,$7FF0                     ;
                        call ScanOptiKeys               ;
                        jr nc,DIlp                      ;

                        jp DispMain                     ;

PrintHS                 push af                         ;
                        ld (HSChar),a                   ;

                        ld hl,sHighC                    ;
                        call PrintStr                   ;

                        push ix                         ;
                        pop hl                          ;

                        ld a,(EntryF)                   ;
                        or a                            ;
                        jr nz,PHSb                      ;

PHSa                    ld a,(hl)                       ;
                        or a                            ;
                        inc hl                          ;
                        jr nz,PHSa                      ;

                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld h,(hl)                       ;
                        ld l,a                          ;

                        ld de,(DScore)                  ;
                        or a                            ;
                        sbc hl,de                       ;
                        jr nc,PHSb                      ;

                        ld a,1                          ;
                        ld (EntryF),a                   ;

                        ld hl,(pCurY)                   ;
                        ld (EntryY),hl                  ;

                        ld (pInsert),ix                 ;

                        ex de,hl                        ;
                        jr PHSx                         ;

PHSb                    ld a,(ix)                       ;
                        or a                            ;
                        inc ix                          ;
                        jr z,PHS2a                      ;

                        call Print                      ;
                        jr PHSb                         ;

PHS2a                   ld l,(ix)                       ;
                        inc ix                          ;
                        ld h,(ix)                       ;
                        inc ix                          ;
                        ld (pHSEnd),ix                  ;

PHSx                    ld a,255 - (5*6)                ;
                        ld (pCurX),a                    ;

                        ld a,cYellow                    ;
                        call Print                      ;

                        call PrintScore                 ;

                        ld a,"0"                        ;
                        call Print                      ;

                        ld a,cCret                      ;
                        call Print                      ;

                        pop af                          ;
                        ret                             ;

PHS2                    inc ix                          ;

PHS3                    call PrintSp                    ;
                        djnz PHS3                       ;

                        jr PHS2a                        ;

PrintSp                 push af                         ;
                        ld a," "                        ;
                        call Print                      ;
                        pop af                          ;
                        ret                             ;

PrintSp2                push af                         ;
                        ld a,$80                        ;
                        call Print                      ;
                        pop af                          ;
                        ret                             ;

PrintScore1             ld c,$80                        ;
                        ld b,4                          ;
                        jr PS0                          ;

PrintScore              ld c,0                          ;
                        ld b,4                          ;
PS0                     call PS1                        ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        djnz PS0                        ;
                        ret                             ;

PS1                     ld a,h                          ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        and $0F                         ;
                        jr z,PS1a                       ;
                        inc c                           ;
                        or "0"                          ;
                        jp Print                        ;

PS1a                    ld a,c                          ;
                        cp $80                          ;
                        ret z                           ;
                        and $7F                         ;
                        jr z,PS2                        ;
                        ld a,"0"                        ;
                        jp Print                        ;

PS2                     ld a,(pCurX)                    ;
                        add a,6                         ;
                        ld (pCurX),a                    ;
                        ret                             ;

        if enabled bFreeVersion
OptiData                defw 0,sSkillLevels             ;
                        defb 1                          ;
                        defb $7C                        ;
                        defb -1,-2,-3,-4,-5             ;
                        defw AType                      ;
                        defs 3                          ;

                        defw 0,sNoises                  ;
                        defb 3                          ;
                        defb $78                        ;
                        defb $00,$09,$0F,$FF,$FF        ;
                        defw BType                      ;
                        defs 3                          ;

                        defw 0,sDisplay                 ;
                        defb 1                          ;
                        defb $70                        ;
                        defb 0,2,3,0,0                  ;
                        defw CType                      ;
                        defs 3                          ;
        else
OptiData                defw 0,sSkillLevels             ;
                        defb 2                          ;
                        defb $7C                        ;
                        defb -1,-2,-3,-4,-5             ;
                        defw AType                      ;
                        defs 3                          ;

                        defw 0,sNoises                  ;
                        defb 3                          ;
                        defb $78                        ;
                        defb $00,$09,$0F,$FF,$FF        ;
                        defw BType                      ;
                        defs 3                          ;

                        defw 0,sDisplay                 ;
                        defb 1                          ;
                        defb $70                        ;
                        defb 0,2,3,0,0                  ;
                        defw CType                      ;
                        defs 3                          ;
        endif

VecGoto                 dec a                           ;
                        add a,a                         ;
                        ld l,a                          ;
                        ld h,0                          ;
                        add hl,de                       ;
                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld h,(hl)                       ;
                        ld l,a                          ;
FrontCallHL             jp (hl)                         ;

MainVecTab              defw DispGame                   ; 1
                        defw DispInst                   ; 2
                        defw DispCont                   ; 3
                        defw DispOpti                   ; 4
                        defw DispDemo                   ; 5
                        defw DispMain                   ; 6
                        defw DispMain                   ; 7
                        defw DispMain                   ; 8
                        defw DispMain                   ; 9
                        defw DispMain                   ; 10
                        defw DispHS                     ; 11

ScanOptiKeys            push ix                         ;
                        push de                         ;
                        push bc                         ;

                        call SOK                        ;

                        pop bc                          ;
                        pop de                          ;
                        pop ix                          ;
                        ret                             ;

SOK                     ld ix,OptKeyTab                 ;
                        ld e,12                         ;

SOKlp                   rl c                            ;
                        rl b                            ;
                        jr c,SOK0                       ;

                        push bc                         ;
                        ld bc,4                         ;
                        add ix,bc                       ;
                        pop bc                          ;

SOKx                    dec e                           ;
                        jr nz,SOKlp                     ;

                        or a                            ;
                        ret                             ;

SOK0                    call SOK1                       ;
                        ret c                           ;

                        jr SOKx                         ;

SOK1                    push bc                         ;

                        ld b,(ix)                       ;
                        ld c,$FE                        ;
                        in a,(c)                        ;

                        or (ix+1)                       ;
                        inc a                           ;

                        jr z,SOKnp                      ;

                        ld a,(ix+2)                     ;
                        and $0F                         ;
                        cp 4                            ;
                        jr z,SOK2                       ;

                        inc (ix+2)                      ;

SOKxf                   ld bc,4                         ;
                        add ix,bc                       ;
                        or a                            ;

                        pop bc                          ;
                        ret                             ;

SOK2                    bit 7,(ix+2)                    ;
                        jr nz,SOKxf                     ;

                        set 7,(ix+2)                    ;

                        ld a,(ix+3)                     ;

                        ld bc,4                         ;
                        add ix,bc                       ;

                        scf                             ;
                        pop bc                          ;
                        ret                             ;

SOKnp                   ld a,(ix+2)                     ;
                        and $0F                         ;
                        jr z,SOKxf                      ;

                        dec (ix+2)                      ;

                        dec a                           ;
                        and $0F                         ;
                        jr nz,SOKxf                     ;

                        res 7,(ix+2)                    ;

                        jr SOKxf                        ;

IntRoutine              push af                         ;
                        push hl                         ;

                        ld a,(CType)                    ;
                        cp 3                            ;
                        jr z,IntIgnore                  ;

                        push bc                         ;
                        push de                         ;
                        push ix                         ;
                        push iy                         ;

                        ld a,(SecCount)                 ;
                        and $01                         ;
                        jr z,Int0                       ;

                        call ScrollScore                ;

                        ld a,(ADamage)                  ;
                        ld b,a                          ;
                        ld a,(DDamage)                  ;
                        cp b                            ;

                        call nz,StepEnergy              ;

Int0                    call ScMess                     ;

                        ld a,(SecCount)                 ;
                        dec a                           ;
                        ld (SecCount),a                 ;

                        cp 25                           ;
                        jr z,Int2                       ;

                        or a                            ;
                        call z,SetUpSec                 ;

                        ld a,(Slice)                    ;
                        or a                            ;
                        jr z,Int1                       ;

                        dec a                           ;
                        ld (Slice),a                    ;

                        call ScrollIt                   ;

Int1                    pop iy                          ;
                        pop ix                          ;
                        pop de                          ;
Crash                   pop bc                          ;
                        pop hl                          ;
                        pop af                          ;
                        ei                              ;
                        ret                             ;

Int2                    ld a,$00                        ; Colons OFF
                        ld ($0000),a                    ; SMC
CM1                     equ .-2                         ;
                        ld ($0000),a                    ; SMC
CM2                     equ .-2                         ;
                        jp Int1                         ;

IntIgnore               ld a,(DDamage)                  ;
                        ld (ADamage),a                  ;

                        ld hl,(DScore)                  ;
                        ld (AScore),hl                  ;

                        ld a,(SecCount)                 ;
                        dec a                           ;
                        ld (SecCount),a                 ;

                        pop hl                          ;
                        pop af                          ;
                        ei                              ;
                        ret                             ;

RotDig                  xor a                           ;
                        add hl,hl                       ;
                        rla                             ;
                        add hl,hl                       ;
                        rla                             ;
                        add hl,hl                       ;
                        rla                             ;
                        add hl,hl                       ;
                        rla                             ;
                        ret                             ;

ScNext                  ld hl,(ScPtr)                   ;
                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld (ScPtr),hl                   ;
                        inc a                           ;
                        ld (Sc_F),a                     ;
                        jp z,ScNew                      ;

                        dec a                           ;
                        jr z,ScN2                       ;

                        cp $20                          ;
                        jr nc,ScN1                      ;

                        ld (ScAttr),a                   ;

                        ld a,3                          ;
                        ld (ScCnt),a                    ;

                        ld hl,Buff0                     ;
                        ld de,Buff1                     ;
                        ld bc,7                         ;
                        ld (hl),$00                     ;
                        ldir                            ;

                        jr ScIt                         ;

ScN1                    ld l,a                          ;
                        ld h,wChars/256                 ;
                        ld a,(hl)                       ;
                        inc a                           ;
                        sra a                           ;
                        ld (ScCnt),a                    ;
                        ld h,0                          ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,hl                       ;
                        ld a,(pChars/256)-1             ; Some assemblers can't handle this.
                        add a,h                         ;
                        ld h,a                          ;
                        ld de,Buff0                     ;
                        ld bc,8                         ;
                        ldir                            ;
                        jr ScIt                         ;

ScN2                    ld a,$7F                        ;
                        ld (ScCnt),a                    ;
                        jr ScIt                         ;

ScMess                  ld a,(Sc_F)                     ;
                        or a                            ;
                        jp z,ScNew                      ;

                        ld a,(ScCnt)                    ;
                        or a                            ;
                        jr z,ScNext                     ;

                        dec a                           ;
                        ld (ScCnt),a                    ;

ScIt                    ld a,(ScACnt)                   ;
                        dec a                           ;
                        ld (ScACnt),a                   ;

                        and $3                          ;
                        call z,ScAtt                    ;

                        ld hl,Buff0                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$50FF                     ;
                        call Sc1m                       ;

                        ld hl,Buff1                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$51FF                     ;
                        call Sc1m                       ;

                        ld hl,Buff2                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$52FF                     ;
                        call Sc1m                       ;

                        ld hl,Buff3                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$53FF                     ;
                        call Sc1m                       ;

                        ld hl,Buff4                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$54FF                     ;
                        call Sc1m                       ;

                        ld hl,Buff5                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$55FF                     ;
                        call Sc1m                       ;

                        ld hl,Buff6                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$56FF                     ;
                        call Sc1m                       ;

                        ld hl,Buff7                     ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        sla (hl)                        ;
                        ex af,af'                       ;
                        ld hl,$57FF                     ;

Sc1m                    ld b,8                          ;

Sc2m                    rl (hl)                         ;

                        ex af,af'                       ;
                        rl (hl)                         ;
                        ex af,af'                       ;
                        dec l                           ;
                        rl (hl)                         ;
                        ex af,af'                       ;
                        rl (hl)                         ;
                        ex af,af'                       ;
                        dec l                           ;
                        rl (hl)                         ;
                        ex af,af'                       ;
                        rl (hl)                         ;
                        ex af,af'                       ;
                        dec l                           ;
                        rl (hl)                         ;
                        ex af,af'                       ;
                        rl (hl)                         ;
                        ex af,af'                       ;
                        dec l                           ;

                        djnz Sc2m                       ;

                        ret                             ;

ScAtt                   ld hl,$5AE1                     ;
                        ld de,$5AE0                     ;
                        ld bc,$1F                       ;
                        ldir                            ;

                        ld a,(ScAttr)                   ;
                        ld (de),a                       ;

                        ret                             ;

ScNew                   ld ix,$0000                     ;
pScrBuf2                equ .-2                         ;

                        ld a,(ix+2)                     ;
                        or a                            ;
                        ret z                           ;

                        ld a,1                          ;
                        ld (Sc_F),a                     ;

                        ld l,(ix)                       ;
                        ld h,(ix+1)                     ;
                        ld (ix+2),$00                   ;

                        ld (ScPtr),hl                   ;

ScNew1                  push ix                         ;
                        pop hl                          ;

                        inc hl                          ;
                        inc hl                          ;
                        inc hl                          ;

                        ld de,SetUpSec                  ;
                        ld (pScrBuf2),hl                ;
                        or a                            ;
                        sbc hl,de                       ;
                        ret nz                          ;

                        ld hl,ScrollBuff                ;
                        ld (pScrBuf2),hl                ;

                        ret                             ;

AddScroll               ld a,(CType)                    ;
                        cp 3                            ;
                        ret z                           ;

                        push ix                         ;
                        di                              ;
                        ld ix,$0000                     ;
pScrBuf1                equ .-2                         ;

                        ld a,(ix+2)                     ;
                        or a                            ;
                        jr nz,AScx                      ;

                        ld (ix),l                       ;
                        ld (ix+1),h                     ;
                        ld (ix+2),1                     ;

                        push ix                         ;
                        pop hl                          ;

                        inc hl                          ;
                        inc hl                          ;
                        inc hl                          ;

                        ld (pScrBuf1),hl                ;

                        ld de,SetUpSec                  ;
                        or a                            ;
                        sbc hl,de                       ;
                        jr nz,AScx                      ;

                        ld hl,ScrollBuff                ;
                        ld (pScrBuf1),hl                ;

AScx                    pop ix                          ;
                        ei                              ;
                        ret                             ;

InitScroll              xor a                           ;
                        ld (Sc_F),a                     ;
                        ld (ScCnt),a                    ;
                        ld (ScACnt),a                   ;

                        ld hl,ScrollBuff                ;
                        ld (pScrBuf1),hl                ;
                        ld (pScrBuf2),hl                ;

                        ld hl,ScrollBuff                ;
                        ld de,ScrollBuff+1              ;
                        ld bc,29                        ;
                        ld (hl),0                       ;
                        ldir                            ;

                        ret                             ;

ScrollBuff              defs 30                         ;

SetUpSec                ld a,8                          ;
                        ld (Slice),a                    ;

                        ld a,50                         ;
                        ld (SecCount),a                 ;

                        ld a,$47                        ;
CM0                     equ .-1                         ;

                        ld ($0000),a                    ;
CM1a                    equ .-2                         ;

                        ld ($0000),a                    ;
CM2a                    equ .-2                         ;

                        call AddOne                     ;

                        ld a,b                          ;
                        ld (nScroll),a                  ;

                        ret                             ;

AddOne                  ld de,FirstDig                  ;
                        ld hl,p1                        ;
                        ld b,1                          ;
                        call DoTen                      ;
                        ret c                           ;

                        call DoSix                      ;
                        ret c                           ;

                        call DoTen                      ;
                        ret c                           ;

                        call DoSix                      ;
                        ret c                           ;

                        call DoTen                      ;
                        ret c                           ;

                        call DoTen                      ;
                        dec b                           ;

                        ret                             ;

DoTen                   ld a,(de)                       ;
                        inc a                           ;
                        ld (de),a                       ;
                        cp 10                           ;
                        ret c                           ;

                        ld (hl),ScBase & $FF            ;
                        inc hl                          ;
                        ld (hl),ScBase / 256            ;
                        inc hl                          ;

                        xor a                           ;
                        ld (de),a                       ;

                        inc b                           ;
                        inc de                          ;

                        ret                             ;

DoSix                   ld a,(de)                       ;
                        inc a                           ;
                        ld (de),a                       ;
                        cp 6                            ;
                        ret c                           ;

                        ld (hl),ScBase & $FF            ;
                        inc hl                          ;
                        ld (hl),ScBase / 256            ;
                        inc hl                          ;

                        xor a                           ;
                        ld (de),a                       ;

                        inc b                           ;
                        inc de                          ;

                        ret                             ;

ScrollIt                ld ix,p1                        ;
                        ld a,(nScroll)                  ;
                        ld b,a                          ;

SIlp                    ld e,(ix)                       ;
                        ld d,(ix+1)                     ;

                        ld l,(ix+12)                    ;
                        ld h,(ix+13)                    ;

                        ld c,8                          ;

SIlp1                   ld a,(de)                       ;
                        inc de                          ;
                        ld (hl),a                       ;
                        inc h                           ;
                        dec c                           ;

                        jr nz,SIlp1                     ;

                        inc (ix)                        ;
                        inc ix                          ;
                        inc ix                          ;

                        djnz SIlp                       ;

                        ret                             ;

UDKWS                   defs 7*64,0                     ;

DispGame                xor a                           ;

DispGame1               ld (Mode),a                     ;

        if not enabled Original
                        xor a                           ; Assume we don't use the analog JS
                        ld (bUseAnalogJS),a             ;
        endif

                        ld a,cCls                       ;
                        call Print                      ;

                        ld a,(cInput)                   ;
                        cp "J"                          ;
                        jp z,GameJoy                    ;

                        call DoKeys                     ;

GameExit                call InitInt                    ;

                        call InitInst                   ;

                        ld a,(CType)                    ;
                        cp 3                            ;
                        jp z,Play1                      ;

                        call InitClock                  ;

                        call InitScore                  ;

                        call InitEnergy                 ;

Play1                   call IntVec                     ;

                        ld a,(Mode)                     ;
                        ld hl,FUM                       ;
                        or a                            ;
                        jr z,Mess1                      ;

                        ld hl,FUD                       ;

Mess1                   call AddScroll                  ;

                        ld a,(BType)                    ;
                        bit 3,a                         ;
                        call SetSoundFlag               ;
                        ld (Trumpet),a                  ;
                        ld (Trumpet1),a                 ;

                        ; Now, as a safeguard against hackers using the monitor to call it, we kill the space-invaders game

        if not enabled Original
                        ld a,$C9                        ; Kill the space-invaders game, we've written all over it
                        ld (SpaceInvaders.Start),a      ; Note the beautiful procedure-scope labelling scheme.
        endif

                        call Play                       ; Play the game

                        di                              ;

                        ld a,(Mode)                     ;
                        or a                            ;
                        jp nz,DispMain                  ;

                        ld a,(EndState)                 ;
                        dec a                           ;
                        jr z,EndEsc                     ;

EndDead                 ld hl,sEndDead                  ;
                        call PrintStr                   ;

                        ld hl,(DScore)                  ;
                        call PrintScore1                ;

                        ld hl,sEndDead1                 ;
                        call PrintStr                   ;

                        jp EElp                         ;

EndEsc                  ld hl,sEndEsc                   ;
                        call PrintStr                   ;

                        call GetString                  ;

                        ld ix,HSBuffer                  ;

                        call FindCRC                    ; The correct str -> hl=$DF51

                        ld de,$DF51                     ;
                        or a                            ;
                        sbc hl,de                       ;
                        jr z,CodeFound1                 ;

                        ld hl,sWrongCode                ;
                        call PrintStr                   ;

EElp                    ld bc,$FFD0                     ;
                        call ScanOptiKeys               ;
                        jr nc,EElp                      ;

                        jp DispHS1                      ;

CodeFound1              ld hl,(DScore)                  ;

                        ld a,$05                        ;
                        add a,h                         ;
                        daa                             ;
                        ld h,a                          ;

                        jr nc,CF2                       ;

                        ld hl,$9999                     ;

CF2                     ld (DScore),hl                  ;

                        ld ix,HSBuffer+2                ;

                        call FindCRC                    ; The correct str -> hl=$041D

                        ex de,hl                        ;

                        ld hl,Message                   ;

CodeFlp                 ld a,(hl)                       ;
                        xor d                           ;
                        add a,e                         ;
                        jr z,EElp                       ;

                        call Print                      ;
                        inc hl                          ;

                        ld bc,MessWait                  ;

MessW                   cpi                             ;
                        dec hl                          ;
                        jp pe,MessW                     ;

                        jr CodeFlp                      ;

FindCRC                 ld hl,0                         ;
                        ld de,4                         ;
                        ld a,8                          ;

DecLp                   ld c,(ix)                       ;
                        ld b,(ix+1)                     ;
                        add hl,bc                       ;

                        add ix,de                       ;

                        dec a                           ;
                        jr nz,DecLp                     ;

                        ret                             ;

SetSoundFlag            ld a,$00                        ;
                        ret z                           ;

                        ld a,$F8                        ;
                        ret                             ;

; Report problems to the user... Bad idea...

FuckUp                  di                              ;

                        pop hl                          ;
                        ld sp,0                         ;
                        push hl                         ;

                        ld hl,sFuckUp                   ;
                        call PrintStr                   ;

                        pop hl                          ;
                        dec hl                          ;
                        dec hl                          ;
                        dec hl                          ;
                        call PrintHex16                 ;

FUlp                    ld bc,$0020                     ;
                        call ScanOptiKeys               ;
                        jr nc,FUlp                      ;

                        jp Boot                         ;

PrintHex16              ld a,h                          ;
                        call PrintHex8                  ;

                        ld a,l                          ;

PrintHex8               call PH2                        ;

PH2                     rrca                            ;
                        rrca                            ;
                        rrca                            ;
                        rrca                            ;

                        push af                         ;

                        and $0F                         ;

                        add a,"0"                       ;
                        cp "9"+1                        ;
                        jr c,PH3                        ;

                        add a,"A"-("9"+1)               ;

PH3                     call Print                      ;

                        pop af                          ;
                        ret                             ;


InitEnergy              xor a                           ;
                        ld (ADamage),a                  ;
                        ld (cMag),a                     ;

                        ld a,MaxEnergy                  ;
                        ld (DDamage),a                  ;

                        ld de,$50A6                     ;

                        ld a,(CType)                    ;
                        or a                            ;
                        jr z,IEa                        ;

                        ld de,$50A9                     ;

IEa                     ld (pcDial),de                  ;

                        ld hl,Dial0                     ;
                        ld (pcShape),hl                 ;

                        ld b,nDials                     ;

IElp                    push de                         ;
                        push bc                         ;

                        ld hl,Dial0                     ;
                        call Place                      ;

                        pop bc                          ;
                        pop de                          ;

                        inc de                          ;
                        inc de                          ;

                        djnz IElp                       ;

                        ret                             ;


StepEnergy              jr nc,SEinc                     ;

                        ld a,$F8                        ;
Trumpet                 equ .-1                         ;
                        out ($FE),a                     ;

                        ld a,$00                        ;
cMag                    equ .-1                         ;

                        or a                            ;

                        ld de,(pcDial)                  ;
                        ld hl,(pcShape)                 ;

                        jr nz,SEdec1                    ;

                        dec de                          ;
                        dec de                          ;

                        ld (pcDial),de                  ;

                        ld hl,Dial8+32                  ;
                        ld a,9                          ;

SEdec1                  dec a                           ;
                        ld (cMag),a                     ;

                        ld a,(ADamage)                  ;
                        dec a                           ;

                        ld bc,-32                       ;

                        jp SEexit                       ;

SEinc                   ld a,$F8                        ;
Trumpet1                equ .-1                         ;
                        out ($FE),a                     ;

                        ld a,(cMag)                     ;
                        cp 8                            ;

                        ld de,(pcDial)                  ;
                        ld hl,(pcShape)                 ;

                        jr nz,SEinc1                    ;

                        inc de                          ;
                        inc de                          ;

                        ld (pcDial),de                  ;

                        ; This next bit is intentionally devious. It's the piracy check
                        ;
                        ; We will have set the top-bit of the R register if we think
                        ; the game is NOT pirated.
                        ;
                        ; This code reads the R register and checks for this.

        if not enabled No_Check

                        ; This next bit is intentionally devious. It's the piracy check
                        ;
                        ; We will have set the top-bit of the R register if we think
                        ; the game is NOT pirated.
                        ;
                        ; This code reads the R register and checks for this.

                        ld hl,Protect                   ; Unscramble the LD A,R inst.
                        rlc (hl)                        ;

                        noflow                          ; Don't warn when executing data

                        defb $ED                        ; Scrambled LD A,R
Protect                 defb $AF                        ;

                        add a,a                         ; Carry set if bit 7 or R set

                        jp nc Crash                     ; Cause a crash if it isn't

                        rrc (hl)                        ; Scramble it again

        endif

                        ; Carry on

                        ld hl,Dial0-32                  ;
                        ld a,-1                         ;

SEinc1                  inc a                           ;
                        ld (cMag),a                     ;

                        ld bc,32                        ;

                        ld a,(ADamage)                  ;
                        inc a                           ;
SEexit                  ld (ADamage),a                  ;

                        add hl,bc                       ;
                        ld (pcShape),hl                 ;

                        xor a                           ;
                        out ($FE),a                     ;

Place                   push de                         ;
                        call PInner                     ;
                        pop de                          ;

                        ld a,e                          ;
                        add a,$20                       ;
                        ld e,a                          ;

PInner                  ld b,8                          ;

Inner1                  ld a,(hl)                       ;
                        ld (de),a                       ;

                        inc hl                          ;
                        inc e                           ;

                        ld a,(hl)                       ;
                        ld (de),a                       ;

                        inc hl                          ;
                        dec e                           ;

                        inc d                           ;

                        djnz Inner1                     ;

                        ret                             ;


InitScore               ld hl,ScoreData                 ;
                        ld de,ScorePtrs                 ;
                        ld bc,ScorePtrs-ScoreData       ;
                        ldir                            ;

                        ld hl,0                         ;
                        ld (DScore),hl                  ;

                        ld a,(CType)                    ; Point at the score screen pos
                        ld hl,$50BB                     ;
                        or a                            ;
                        jr z,IS1                        ;

                        ld hl,$50DB                     ;

IS1                     ld (pScore),hl                  ;
                        ret                             ;


ScrollScore             ld a,(ScScrCnt)                 ;
                        dec a                           ;
                        jr nz,SSupdate                  ;

                        ld hl,(AScore)                  ;
                        ld de,(DScore)                  ;
                        or a                            ;
                        sbc hl,de                       ;
                        ret z                           ;

                        ex de,hl                        ;
                        ld (AScore),hl                  ;

                        ld a,0                          ;
                        jr c,SSpos                      ;

                        ld a,7                          ;

SSpos                   ld (ScScrDir),a                 ;

                        ld ix,ScorePtrs                 ;
                        ld iy,1                         ;

                        ld b,4                          ;
                        ld c,ScTab1 & $FF               ;
                        ld d,ScBase/256                 ;

SScalc                  xor a                           ;

                        add hl,hl                       ;
                        adc a,a                         ;
                        add hl,hl                       ;
                        adc a,a                         ;
                        add hl,hl                       ;
                        adc a,a                         ;
                        add hl,hl                       ;
                        adc a,a                         ;

                        push af                         ;

                        cp (ix+1)                       ;
                        ld (ix+1),a                     ;
                        jr z,SSb                        ;

                        ld a,iyh                        ;
                        or a                            ;
                        jr nz,SSb                       ;

                        ld iyh,iyl                      ;

SSb                     pop af                          ;

                        jr z,SSa                        ;

                        ld c,ScTab2 & $FF               ;

SSa                     add a,a                         ;
                        add a,c                         ;

                        ld e,a                          ;

                        ld a,(de)                       ;

                        ld e,a                          ;

                        ld a,(ScScrDir)                 ;
                        add a,e                         ;

                        ld (ix),a                       ;

                        inc iyl                         ;

                        inc ix                          ;
                        inc ix                          ;

                        djnz SScalc                     ;

                        ld a,(ScScrDir)                 ;
                        add a,Sc0 and $FF               ;
                        ld (ix),a                       ;

                        ld a,iyh                        ;
                        ld (ScScrNo),a                  ;

                        ld a,8                          ;

SSupdate                ld (ScScrCnt),a                 ;

                        ld de,ScreenBase                ;
pScore                  equ .-2                         ;

                        ld a,(ScScrNo)                  ;
                        ld iyl,a                        ;

                        ld a,(ScScrDir)                 ;
                        add a,d                         ;
                        cp d                            ;
                        ld d,a                          ;

                        jr nz,SSscdown                  ;

SSscup                  ld hl,ScorePtrs                 ;
                        ld b,5                          ;

SSscuplp                dec iyl                         ;
                        jr nz,SSscupX                   ;
                        inc iyl                         ;

                        push bc                         ;

                        push de                         ;
                        push hl                         ;

                        ld b,7                          ;

                        ld h,d                          ;
                        ld l,e                          ;
                        inc h                           ;

SSscuplp1               ld a,(hl)                       ;
                        ld (de),a                       ;

                        inc h                           ;
                        inc d                           ;

                        djnz SSscuplp1                  ;

                        pop hl                          ;

                        ld c,(hl)                       ;
                        ld b,Sc0/256                    ;

                        ld a,(bc)                       ;
                        ld (de),a                       ;

                        inc (hl)                        ;

                        pop de                          ;

                        pop bc                          ;

SSscupX                 inc e                           ;

                        inc hl                          ;
                        inc hl                          ;

                        djnz SSscuplp                   ;

                        ret                             ;

SSscdown                ld hl,ScorePtrs                 ;
                        ld b,5                          ;

SSscdolp                dec iyl                         ;
                        jr nz,SSscdoX                   ;
                        inc iyl                         ;

                        push bc                         ;

                        push de                         ;
                        push hl                         ;

                        ld b,7                          ;

                        ld h,d                          ;
                        ld l,e                          ;
                        dec h                           ;

SSscdolp1               ld a,(hl)                       ;
                        ld (de),a                       ;

                        dec h                           ;
                        dec d                           ;

                        djnz SSscdolp1                  ;

                        pop hl                          ;

                        ld c,(hl)                       ;
                        ld b,Sc0/256                    ;

                        ld a,(bc)                       ;
                        ld (de),a                       ;

                        dec (hl)                        ;

                        pop de                          ;

                        pop bc                          ;

SSscdoX                 inc e                           ;

                        inc hl                          ;
                        inc hl                          ;

                        djnz SSscdolp                   ;

                        ret                             ;

; Score variables (for the scrolling display)

ScoreData               defw ScS,ScS,ScS,ScS,Sc0        ; Initial data. Copied down
                        defw 0                          ;
                        defb 9,0,1                      ;

        ; The initial data above is copied to these vars to init them

ScorePtrs               defs 5*2                        ;
AScore                  defs 2                          ;
ScScrCnt                defs 1                          ;
ScScrDir                defs 1                          ;
ScScrNo                 defs 1                          ;


GameJoy                 call DoKeys                     ;

                        ld a,(cJoy)                     ;

        if not enabled Original
                        cp 4                            ; Is this the analog joystick?
                        jr z GameJoy_Analog             ; Yes, skip
        endif
                        ; Not analog

                        ld l,a                          ;
                        ld h,0                          ;

                        add hl,hl                       ;

                        ld d,h                          ;
                        ld e,l                          ;

                        add hl,hl                       ;
                        add hl,hl                       ;
                        add hl,de                       ;

                        ld de,JoyVects                  ;
                        add hl,de                       ;

                        ld de,kLeft                     ;
                        ld b,4                          ;

Joy1                    call DoJoy                      ;

                        djnz Joy1                       ;

                        ; Skip the Acc/Del keys

                        inc de                          ;
                        inc de                          ;
                        inc de                          ;
                        inc de                          ;
                        inc de                          ;
                        inc de                          ;

                        call DoJoy                      ;

                        jp GameExit                     ;

        if not enabled Original
        ; We have an analogue joystick, We leave the keys alone but set the analogue flag

GameJoy_Analog          ld (bUseAnalogJS),a             ; a = 4
                        jp GameExit                     ;
        endif

; Copy a vector

DoJoy                   inc de                          ; Skip the CALL

                        ld a,(hl)                       ; Copy the address
                        ld (de),a                       ;
                        inc hl                          ;
                        inc de                          ;

                        ld a,(hl)                       ;
                        ld (de),a                       ;
                        inc hl                          ;
                        inc de                          ;
                        ret                             ;

; Addresses of Joystick scanning routines

JoyVects                defw KemL,KemR,KemU,KemD,KemF   ; Left,Right,Up,Down,Fire
                        defw FulL,FulR,FulU,FulD,FulF   ;
                        defw ProL,ProR,ProU,ProD,ProF   ;
                        defw SinL,SinR,SinU,SinD,SinF   ;
                        defw SinL,SinR,SinU,SinD,SinF   ;

; Scanning routines for the different types of joystick

KemL                    in a,($1F)                      ;
                        bit 1,a                         ;
                        ret                             ;

KemR                    in a,($1F)                      ;
                        bit 0,a                         ;
                        ret                             ;

KemU                    in a,($1F)                      ;
                        bit 3,a                         ;
                        ret                             ;

KemD                    in a,($1F)                      ;
                        bit 2,a                         ;
                        ret                             ;

KemF                    in a,($1F)                      ;
                        bit 4,a                         ;
                        ret                             ;

FulL                    in a,($7F)                      ;
                        cpl                             ;
                        bit 2,a                         ;
                        ret                             ;

FulR                    in a,($7F)                      ;
                        cpl                             ;
                        bit 3,a                         ;
                        ret                             ;

FulU                    in a,($7F)                      ;
                        cpl                             ;
                        bit 0,a                         ;
                        ret                             ;

FulD                    in a,($7F)                      ;
                        cpl                             ;
                        bit 1,a                         ;
                        ret                             ;

FulF                    in a,($7F)                      ;
                        cpl                             ;
                        bit 7,a                         ;
                        ret                             ;

ProL                    ld a,$F7                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 4,a                         ;
                        ret                             ;

ProR                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 2,a                         ;
                        ret                             ;

ProU                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 3,a                         ;
                        ret                             ;

ProD                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 4,a                         ;
                        ret                             ;

ProF                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 0,a                         ;
                        ret                             ;

SinL                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 4,a                         ;
                        ret                             ;

SinR                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 3,a                         ;
                        ret                             ;

SinU                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 1,a                         ;
                        ret                             ;

SinD                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 2,a                         ;
                        ret                             ;

SinF                    ld a,$EF                        ;
                        in a,($FE)                      ;
                        cpl                             ;
                        bit 0,a                         ;
                        ret                             ;

; This code compiles the user defined keys into the fastest code to read them

DoKeys                  ld ix,kLeft                     ;
                        ld iy,UDKWS                     ;
                        ld de,UDKTab                    ;
                        ld b,8                          ;

Game1                   push bc                         ;
                        push de                         ;

                        ld hl,HSBuffer                  ;
DK1                     ld a,(de)                       ;
                        cp 40                           ;
                        jr nc,DK2                       ;

                        call Conv                       ;

                        ld (hl),b                       ;
                        inc hl                          ;
                        ld (hl),c                       ;
                        inc hl                          ;
                        inc de                          ;

                        jr DK1                          ;

Conv                    ld bc,$FEFE                     ;
                        inc a                           ;
Conv1                   dec a                           ;
                        ret z                           ;

                        rlc c                           ;
                        bit 5,c                         ;
                        jr nz,Conv1                     ;

                        ld c,$FE                        ;
                        rlc b                           ;
                        jr Conv1                        ;

DK2                     ld (hl),0                       ;

                        ld de,HSBuffer-2                ;

DK3                     inc de                          ;
                        inc de                          ;

                        ld a,(de)                       ;
                        or a                            ;
                        jr z,DK5                        ;

                        ld h,d                          ;
                        ld l,e                          ;

DK4                     inc hl                          ;
                        inc hl                          ;

                        ex af,af'                       ;
                        ld a,(hl)                       ;
                        or a                            ;
                        jr z,DK3                        ;

                        ex af,af'                       ;
                        cp (hl)                         ;
                        jr nz,DK4                       ;

                        inc de                          ;
                        inc hl                          ;

                        ex af,af'                       ;
                        ld a,(de)                       ;
                        and (hl)                        ;
                        ld (de),a                       ;
                        ex af,af'                       ;

                        ld (hl),$FF                     ;
                        dec hl                          ;
                        dec de                          ;
                        ld (hl),$FF                     ;

                        jr DK4                          ;

DK5                     ld de,HSBuffer-2                ;

DK5a                    inc de                          ;
                        inc de                          ;

                        ld a,(de)                       ;
                        or a                            ;
                        jr z,DK5c                       ;

                        cp $FF                          ;
                        jr z,DK5a                       ;

                        inc de                          ;
                        ld a,(de)                       ;
                        dec de                          ;
                        ld h,d                          ;
                        ld l,e                          ;
                        inc hl                          ;

DK5b                    inc hl                          ;

                        ex af,af'                       ;
                        ld a,(hl)                       ;
                        or a                            ;
                        jr z,DK5a                       ;

                        ex af,af'                       ;
                        inc hl                          ;
                        cp (hl)                         ;
                        jr nz,DK5b                      ;

                        dec hl                          ;
                        ex af,af'                       ;
                        ld a,(de)                       ;
                        and (hl)                        ;
                        ld (de),a                       ;
                        ex af,af'                       ;

                        ld (hl),$FF                     ;
                        inc hl                          ;
                        ld (hl),$FF                     ;
                        jr DK5b                         ;

DK5c                    ld (ix),$C3                     ;
                        ld a,iyl                        ;
                        ld (ix+1),a                     ;
                        ld a,iyh                        ;
                        ld (ix+2),a                     ;

                        inc ix                          ;
                        inc ix                          ;
                        inc ix                          ;

                        ld hl,HSBuffer-2                ;

DK6                     inc hl                          ;
                        inc hl                          ;

DK7                     ld a,(hl)                       ;
                        or a                            ;
                        jr z,DK8                        ;

                        cp $FF                          ;
                        jr z,DK6                        ;

                        ld (iy),$3E                     ;
                        inc iy                          ;

                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld (iy),a                       ;
                        inc iy                          ;

                        ld (iy),$DB                     ;
                        inc iy                          ;

                        ld (iy),$FE                     ;
                        inc iy                          ;

                        ld (iy),$F6                     ;
                        inc iy                          ;

                        ld a,(hl)                       ;
                        inc hl                          ;
                        ld (iy),a                       ;
                        inc iy                          ;

                        ld (iy),$3C                     ;
                        inc iy                          ;

                        ld (iy),$C0                     ;
                        inc iy                          ;

                        jr DK7                          ;

DK8                     ld (iy-1),$C9                   ;

                        pop de                          ;
                        pop bc                          ;

                        ld a,e                          ;
                        or $0F                          ;
                        ld e,a                          ;

                        inc de                          ;
                        dec b                           ;
                        jp nz,Game1                     ;

                        ret                             ;

; Init the interrupt handler

InitInt                 ld hl,IntPage                   ;
                        ld b,0                          ;
                        ld a,IntVec/256                 ;

IIlp                    ld (hl),a                       ;
                        inc hl                          ;
                        djnz IIlp                       ;

                        ld (hl),a                       ;

                        ld a,1                          ;
                        ld (SecCount),a                 ;

                        xor a                           ;
                        ld (Sc_F),a                     ;

                        ld a,IntPage/256                ;
                        ld i,a                          ;
                        im 2                            ;
                        ret                             ;

; Init the clock display

InitClock               ld hl,ClockDataN                ;
                        ld de,Colon1N                   ;
                        ld bc,Colon2N                   ;

                        ld a,(CType)                    ;
                        or a                            ;
                        ld a,$47                        ;
                        jr z,IC0                        ;

                        ld a,$7                         ;
                        ld hl,ClockDataR                ;
                        ld de,Colon1R                   ;
                        ld bc,Colon2R                   ;

IC0                     ld (CM1),de                     ;
                        ld (CM1a),de                    ;

                        ld (CM2),bc                     ;
                        ld (CM2a),bc                    ;

                        ld (CM0),a                      ;

                        ld de,p1                        ;
                        ld bc,CDEnd-ClockDataN          ;
                        ldir                            ;

                        ld a,(CType)                    ;
                        or a                            ;
                        ld a,$1C                        ;
                        jr z,IC2                        ;

                        ld hl,$52C2                     ;
                        call IC1                        ;
                        ld hl,$52C5                     ;

IC1                     ld (hl),a                       ;
                        inc h                           ;
                        ld (hl),a                       ;
                        inc h                           ;

                        inc h                           ;
                        ld (hl),a                       ;
                        inc h                           ;
                        ld (hl),a                       ;

                        ret                             ;

IC2                     ld hl,$420E                     ;

                        call IC1                        ;

                        ld hl,$4211                     ;

                        jr IC1                          ;


InitInst                ld a,(CType)                    ;
                        or a                            ;
                        jr z,InitIN                     ;

                        cp 3                            ;
                        jp z,InitIt                     ;

                        ld a,0                          ;
                        ld (pCurX),a                    ;

                        ld hl,$50A0                     ;
                        ld (pCurY),hl                   ;

                        call PrintStr1                  ;
                        noflow
                        defb "Energy",0

                        ld a,$CE                        ;
                        ld (pCurX),a                    ;

                        call PrintStr1                  ;
                        noflow
                        defb "Angle",0

                        ld de,$5AA0                     ;
                        ld hl,BottDefNR                 ;

NR1                     call SetAttr                    ;

                        jp InitScroll                   ;

; Init the instruments

InitIN                  xor a                           ;
                        ld (pCurX),a                    ;

                        ld hl,ScreenBase                ;
                        ld (pCurY),hl                   ;

                        call PrintStr1                  ;
                        noflow
                        defb "Angle",0

                        xor a                           ;
                        ld (pCurX),a                    ;

                        ld hl,$50A0                     ;
                        ld (pCurY),hl                   ;

                        call PrintStr1                  ;
                        noflow
                        defb "Energy",0

                        ld a,$B8                        ;
                        ld (pCurX),a                    ;

                        call PrintStr1                  ;
                        noflow
                        defb "Score",0

                        ld de,Attrs                     ;
                        ld hl,TopDefN                   ;
                        call SetAttr                    ;

                        ld de,$5A80                     ;
                        ld hl,BottDefN                  ;
                        call SetAttr                    ;

                        call InitScroll                 ;

                        ld hl,$5680                     ;
                        call ILine                      ;

                        ld hl,$4120                     ;
                        call ILine                      ;

                        ret                             ;

; Clear the attributes to bright white/black

InitIt                  ld hl,Attrs                     ;
                        ld de,Attrs+1                   ;
                        ld bc,lAttrs-1                  ;
                        ld (hl),$47                     ;
                        ldir                            ;
                        ret                             ;

; This macro allows full stops to have a space in front, as the ugly original game did
; or not, according to the "Original" source option

mAddPeriod              macro()
        if enabled Original
                          defb " ."
        else
                          defb "."
        endif
                          mend

; Fire-up menu

FUM                     defb $5                         ;
                        defb "Forbidden Planet   "      ;

                        defb $3                         ;
                        defb "(c) "                     ;
                        defb 5                          ;
                        defb "Design"                   ;
                        defb 6                          ;
                        defb "Design"                   ;
                        defb 7                          ;
                        defb "Software"                 ;
                        defb $00,$FF                    ;

; Fire-up demo

FUD                     defb $5                         ;
                        defb "Demo mode"                ;
                        defb $00,$FF                    ;

; Draw a dotted line

ILine                   ld b,$20                        ;

ILine1                  ld (hl),$AA                     ;
                        inc l                           ;
                        djnz ILine1                     ;

                        ret                             ;


SetAttr                 ld a,(hl)                       ;
                        or a                            ;
                        ret z                           ;

                        inc hl                          ;
                        ld b,(hl)                       ;
                        inc hl                          ;

SAlp                    ld (de),a                       ;
                        inc de                          ;
                        djnz SAlp                       ;

                        jr SetAttr                      ;


BottDefNR               defb $43,$19                    ;
                        defb $45,$07                    ;

                        defb $47,$08                    ;
                        defb $43,$11                    ;
                        defb $47,$07                    ;

                        defb $07,$20                    ;
                        defb $00                        ;

BottDefN                defb $47,$20                    ;
                        defb $43,$06                    ;
                        defb $43,$10                    ;
                        defb $46,$05                    ;
                        defb $07,$05                    ;

                        defb $43,$06                    ;
                        defb $43,$10                    ;
                        defb $46,$05                    ;
                        defb $07,$05                    ;

                        defb $47,$20                    ;
                        defb $00                        ;

TopDefN                 defb $45,$06                    ;
                        defb $47,$1A                    ;
                        defb $47,$20                    ;
                        defb $00                        ;

OptKeyTab               defb $FF,$FF,$84,$00            ; Esc
                        defb $F7,$FE,$00,$01            ; "1"
                        defb $F7,$FD,$00,$02            ; "2"
                        defb $F7,$FB,$00,$03            ; "3"
                        defb $F7,$F7,$00,$04            ; "4"
                        defb $F7,$EF,$00,$05            ; "5"
                        defb $EF,$EF,$84,$06            ; "6"
                        defb $EF,$F7,$84,$07            ; "7"
                        defb $EF,$FB,$84,$08            ; "8"
                        defb $EF,$FD,$84,$09            ; "9"
                        defb $BF,$FE,$84,$0A            ; cCret
                        defb $7F,$FE,$00,$0B            ; " "

UDKdesc                 defb $80 or "C","S"             ;
                        defb "ZXCV"                     ;
                        defb "ASDFG"                    ;
                        defb "QWERT"                    ;
                        defb "12345"                    ;
                        defb "09876"                    ;
                        defb "POIUY"                    ;
                        defb $80 or "C","r"             ;
                        defb "LKJH"                     ;
                        defb $80 or "S","p"             ;
                        defb $80 or "S","S"             ;
                        defb "MNB"                      ;

; Menu text

sEndDead                defb cCls,cCret,cCret,cYellow
                        defb "You were killed , scoring "
                        defb cWhite,0

sEndDead1               defb "0 "
                        defb cYellow
                        defb "points"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret,cCyan
                        defb "Press SPACE",0

sEndEsc                 defb cCls,cCret,cCret,cYellow
                        defb "Congratulations ! You escaped from the planet"
                        defb cCret,cCret,cCyan
                        defb "If you can decode it , enter the key"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret,cMagenta,0

sWrongCode              defb cCret,cCret,cCyan
                        defb "Sorry , this key does not decode the message"
                        defb cCret,cCret,cYellow
                        defb "Press SPACE",0

; 061-205-6603 was the number of the Design Design offices. One of us would have answered...

        if enabled Original
sFuckUp                 defb cCls,cYellow
                        defb "Oh dear ! something's gone wrong !"
                        defb cCret,cCret,cCyan
                        defb "Please phone 061-205-6603 and quote this"
                        defb cCret
                        defb "number :- "
                        defb cWhite
                        defb "2.0:",0
        else
sFuckUp                 defb cCls,cYellow
                        defb "Oh dear! something's gone wrong !"
                        defb cCret,cCret,cCyan
                        defb "I'm blaming the emulator..."
                        defb cCret
                        defb "Error :- "
                        defb cWhite
                        defb "2.0:",0
        endif

sHexMon                 defb cCls,cCyan
                        defb "Sorry , this option is not enabled at present"
                        defb cCret,cCret,cWhite
                        defb "Press ENTER",0

sHexMon1                defb cCls,cCyan,$86,$83
                        defb "Quaimon 2"
                        defb cCret,cCret,cYellow
                        defb "(m)od , (t)ab , (e)xec , (q)uit"
                        defb 0

sMonError               defb cCyan
                        defb "Error !"
                        defb 0

        if enabled Original
sMainMenu               defb cWhite,cCls,$86,$86,$82
                        defb "Forbidden Planet"
        else
sMainMenu               defb cWhite,cCls,$86,$84
                        defb "Forbidden Planet 2012"
        endif

                        defb cCret,cCret

        if enabled bFreeVersion
                        defb cMagenta
                        defb "           (Limited free version)"
        else
                        defb cMagenta
                        defb "    Part Three of the Dark Star Trilogy"
        endif

                        defb cCret,cCret
                        defb cWhite
                        defb " 1 "
                        defb cMagenta
                        defb " Play the game"
                        defb cWhite
                        defb cCret,cCret
                        defb " 2 "
                        defb cRed
                        defb " Instructions"
                        defb cWhite
                        defb cCret,cCret
                        defb cCret,cCret
                        defb " 3 "
                        defb cYellow
                        defb " Select the playing keys and joystick"
                        defb cWhite
                        defb cCret,cCret
                        defb " 4 "
        if enabled bFreeVersion
                        defb cRed
                        defb " Change the game options"
                        defb cRed
                        defb cCret
                        defb "    This is not allowed in the free version"
                        defb cCret
                        defb cCret,cCret
        else
                        defb cGreen
                        defb " Change the game options"
                        defb cCret,cCret
                        defb cCret,cCret
        endif
                        defb cWhite
                        defb cCret
                        defb " 5 "
                        defb cCyan
                        defb " Simple demo sheet"
                        defb cCret,cCret
                        defb cCret,cCret
                        defb cMagenta
                        defb "Designed without the aid of a computer"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret
                        defb "(c) Design Design Software"
                        defb 0

        ; These were disassembled back from the object, hence the ugly formatting.

sKeysMenu               defb cCls,$86,$83,$85,cYellow,"Present Controls"
                        defb cCret,cCret
                        defb cWhite," 1  ",cGreen,"Turn left"
                        defb cCret,cCret
                        defb cWhite," 2  ",cGreen,"Turn right"
                        defb cCret,cCret
                        defb cWhite," 3  ",cCyan,"Move Up"
                        defb cCret,cCret
                        defb cWhite," 4  ",cCyan,"Move Down"
                        defb cCret,cCret
                        defb cWhite," 5  ",cYellow,"Accelerate"
                        defb cCret,cCret
                        defb cWhite," 6  ",cYellow,"Decelerate"
                        defb cCret,cCret
                        defb cWhite," 7  ",cCyan,"Fire"
                        defb cCret,cCret
                        defb cWhite," 8  ",cMagenta,"Return to main menu  ",cWhite,"9 ",cMagenta,"Select Joystick"
                        defb cCret,cCret
                        defb cCyan,"Press a number between ",cWhite,"'1' ",cCyan,"and ",cWhite,"'7' "
                        defb cCyan,"to select the control that you wish to change"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret,cYellow," Then type all the keys that you want for"
                        defb cCret
                        defb "that control and finish by typing the ",cWhite,"'1' ",cYellow,"key.",0

sJoysticks              defb cCls,$86,$86,$83,cYellow,"Joystick Menu"
                        defb cCret,cCret,cCret
                        defb " 1  ",cGreen,"Kempston"
                        defb cWhite,cCret,cCret," 2  ",cMagenta,"Fuller Box"
                        defb cCret,cCret,cWhite," 3  ",cYellow,"Protek ( any cursor joystick )"
                        defb cCret,cCret,cWhite," 4  ",cCyan,"Sinclair Interface 2"
        if not enabled Original
                        defb cCret,cCret,cWhite," 5  ",cGreen,"Analogue joystick"
        else
                        defb cCret,cCret,cWhite," 5  ",cGreen,"IEEE Interface"          ; A joke... Don't ask ;)
        endif
                        defb cCret
                        defb cCret,cCret,cWhite," 8  ",cMagenta,"Return to main menu "
                        defb cWhite,        " 9 ",cMagenta,"Select keyboard"
                        defb cCret
                        defb cCret,cCret,cYellow," Please note that even when you select"
                        defb cCret
                        defb "a joystick the keyboard is still used for"
                        defb cCret
                        defb "accelerate & deccelerate"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret,cCyan," If you have a programmable joystick then"
                        defb cCret
                        defb "select the Sinclair and define yours to be"
                        defb cCret
                        defb "6 = Left 7 = Right 9 = Up 8 = Down 0 = Fire"
                        defb 0

sSkillLevels            defb cCls,$86,$86,$86,$81,cCyan,"Skill Levels"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 1  ",cCyan,"Easy"
                        defb cCret,cCret,cWhite," 2  ",cYellow,"Normal"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 3  ",cGreen,"Nasty"
                        defb cCret,cCret,cWhite," 4  ",cMagenta,"Very nasty"
                        defb cCret,cCret,cCret
                        defb cCret,cCret,cWhite," 5  ",cCyan,"Pretty damn devastating !"        ; A joke. See below...
                        defb 0

; Pretty Damn Devastating - PDD - our tape duplicator's were a company with the initials PDD
; (which I think stood for Precision Data Duplication) and this was a vague reference to them. A nice bunch...

sNoises                 defb cCls,$86,$86,$86,$82,cYellow,"Noises"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 1  ",cCyan,"None"
                        defb cCret,cCret,cWhite," 2  ",cYellow,"Strange"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 3  ",cGreen,"Very Strange"
                        defb 0

sDisplay                defb cCls,$86,$86,$86,$82,cMagenta,"Display"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 1  ",cCyan,"Normal"
                        defb cCret,cCret,cWhite," 2  ",cYellow,"Slimline"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 3  ",cGreen,"Wideangle"
                        defb 0

        if enabled bFreeVersion
sOptiMenu               defb cCls,$86,$86,$84,cGreen,"Game Options"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 1  ",cRed,"Change Skill Factors (disabled)"
                        defb cCret,cCret,cWhite," 2  ",cRed,"Change Noises (disabled)"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 3  ",cRed,"Display Format (disabled)"
                        defb cCret,cCret
                        defb cCret,cCret
                        defb cYellow
                        DEFB "Please purchase the game to enable these"
                        DEFB cCret
                        DEFB "options... it's not exactly expensive ;-)"
                        defb cCret
                        defb cCret,cCret
                        defb cCret,cCret
        else
sOptiMenu               defb cCls,$86,$86,$84,cGreen,"Game Options"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 1  ",cCyan,"Change Skill Factors"
                        defb cCret,cCret,cWhite," 2  ",cYellow,"Change Noises"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 3  ",cMagenta,"Display Format"
                        defb cCret,cCret
                        defb cCret,cCret
                        defb cCret,cCret
                        defb cCret,cCret
                        defb cCret,cCret
        endif

sBottom                 defb cCret,cWhite," 8  ",cCyan,"Return to main menu"
                        defb cCret,cCret,cWhite," 9  ",cMagenta,"Return to options menu"
                        defb 0

sInst                   defb cCls,$86,$86,$84,"Instructions"
                        defb cCret
                        defb cCret,cCret,cMagenta," You must find the code segments and"
                        defb cCret,cCret,"decode them"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret,cGreen," All the keys are user-defined except :-"
                        defb cCret,cCret
                        defb cCret,cCret,cWhite," 1  ",cCyan,"Displays map"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret,cWhite," 2  ",cYellow,"Quit Game"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cCret,cCret,cWhite," 3  ",cGreen,"Display codes found"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cWhite
                        defb cCret,cCret,cCret," 4  ",cCyan,"Returns to the game from these"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb 0

sHighA                  defb cCls,$86,$86,$82,"Forbidden Planet"
                        defb cCret,cCret,$86,$86,$84,cCyan,"Hall of Fame"
                        defb cCret,cCret,cCret
                        defb 0

sHighB                  defb cCret,cCret,"  Press ",cCyan,"SPACE ",cYellow
                        defb "to play or ",cCyan,"ENTER ",cYellow,"for options",0

sHighC                  defb cWhite
HSChar                  defb "1",$92,cMagenta,0

sAccept                 defb cCret,cCret,$85,"Please type in your entry"
                        mAddPeriod()                    ; This allows it to be " ." or "."
                        defb cMagenta,0

; The clues for the high-score table modifications...

sClues                  defb "version",0
                        defb "sex",0
                        defb "laser",0
                        defb "fuck",0
                        defb "shit",0
                        defb "help",0
                        defb "designdesign",0
                        defb "pinback",0
                        defb "darkstar",0
                        defb "mon",0
                        defb "corwench",0
                        defb $FF

; The text for the high-score table modifications...

Text                    defb "2.2 ",TIMESTR,0                   ;"Ver 2.2 [Zeus-PC]",0
                        defb "Hmmm. . . tricky !",0
                        defb "2mW Helium-Neon 633 nm",0
                        defb "Oh yes please !",0
                        defb "Shit somewhere else !",0
                        defb "Help ?",0
                        defb "What a what a silly silly name !",0
                        defb "Want yer mouse ?",0
                        defb $22," Hate it ! ",$22,0
                        defb "Let go of my ears - I know my job !",0
                        defb "Nibble nibble !",0
                        defb $FF

; Fire up code. This deletes itself after running to hide the LD R,A instruction
;
; This code sets the top-bit of R, the loader starts the game here if it
; thinks the game hasn't been pirated. How does it know? In the quiet gap
; between sections of tape it looks at how noisy the tape is. An original
; is very quiet, most copies were made using AGC so they're noisy...
;
; Years later someone else claimed this idea as their own. Sic Transit...
;

        if enabled RandomHS
FireUpHack              ldir                            ;

FireUp                  ld bc,$E7FE                     ; "I" key
                        in a,(c)                        ;
                        or $E0                          ;
                        inc a                           ;
                        jp nz SpaceInvaders             ;

                        ld a,r                          ; Set the top bit
                        or $80                          ;
;                and $7f                         ;
                        ld r,a                          ;

                        ld hl,Start                     ;
                        ld (FireUpVector),hl            ;

                        ld hl,FireUpHack                ;
                        ld bc,38                        ;

                        ld ix,$6B00                     ;

                        ldir                            ;

                        jp (ix)                         ;
        else
FireUpHack              ldir                            ;

FireUp                  ld bc,$E7FE                     ; "I" key
                        in a,(c)                        ;
                        or $E0                          ;
                        inc a                           ;
                        jp nz SpaceInvaders             ;

                        ld a,$80                        ; Set the top-bit of R
                        ld r,a                          ; But this kills the random HS

                        ld hl,Start                     ;
                        ld (FireUpVector),hl            ;

                        ld hl,FireUpHack                ;
                        ld bc,36                        ;

                        ld ix,$6B00                     ;

                        ldir                            ;

                        jp (ix)                         ;
        endif

;  Interrupt table here!
;
; The idea is that we fill a page with the same value then put the z80 in
; IM2, the vectored mode. It doesn't matter what the vector value is because
; all addresses point to the same place...
;
                        align 256                       ;

IntPage                 equ $

                        defs $101,(IntPage/256)+1       ;

                        org IntPage+$100 + (IntPage/256)+1 ;
IntVec                  jp IntRoutine                   ;

                        include "fp_game.asm"           ;

                        include "fp_demo.asm"           ;

                        include "fp_maths.asm"          ;

                        include "fp_subs.asm"           ;

                        include "fp_stats.asm"          ;

                        include "fp_stars.asm"          ;

                        include "fp_draw.asm"           ;

                        include "fp_player.asm"         ;

                        include "fp_objects.asm"        ;

CodeEnd                 equ *

; Variables

                        org $E000                       ;

YTable                  defs 256 * 2                    ;

DivTab                  defs 256                        ;

BitTab                  defs 8 * 3                      ;

Colour                  defs 1                          ;

cSoundVal               defs 1                          ;

GameAttr                defs 1                          ;

WindowMask              defs 1                          ;

pObjeList               defs 2                          ;

pMap                    defs 2                          ;

Angle                   defs 1                          ;

ArrowPos                defs 2                          ;

cnStars                 defs 1                          ;

DeltaX                  defs 2                          ;
DeltaY                  defs 2                          ;
DeltaZ                  defs 2                          ;

GroundX                 defs 2                          ;
GroundY                 defs 2                          ;
GroundZ                 defs 2                          ;

XTurn                   defs 2                          ;
YTurn                   defs 2                          ;
XTurnSum                defs 4                          ;

CellCount               defs 2                          ;

FireDX                  defs 2                          ;
FireDY                  defs 2                          ;
FireDZ                  defs 2                          ;

Distance                defs 2                          ;

pcWindow                defs 2                          ;

StarTable               defs nStars * lStar             ;

ObjeTable               defs nObjes * lObje             ;

LineTable               defs nLines * lLine             ;

                        defs 12                         ; ?? Gawd knows...

WindowTable             equ $                           ; Plus an unknown number of elephants!!!

;zeusprinthex "Code ends ",CodeEnd,"WindowTable starts ",*

                        include "fp_inv.asm"            ; Add the space-invaders game

; These commands tell Zeus where to put the code it generates

; This command tells Zeus where to put the code it generates. As a szx file...
; Alter the path to suit your system

; Warn if there are any strange options set

        if enabled bAnalogDefault
                        zeusprint "                                               WARNING! Analogue Joystick is the default"
        endif

        if (enabled Elephants) or (not enabled No_Check)
                        output_szx OutputDir+"\fpunusual.szx",$0000,Main      ; The szx file
                        zeusprint "********************************************   WARNING! No files written!"
        else
          if enabled bFreeVersion
                        output_szx OutputDir+"\fpfree.szx",$0000,Main      ; The szx file
                        zeusprint "                                               Written free version"
          else
                        output_szx OutputDir+"\fp.szx",$0000,Main      ; The szx file
                        zeusprint "                                               Written full version"
          endif
        endif

; Messy stuff at the end

        if ZEUSVER < 27
                        zeuserror "Please upgrade Zeus - the latest version can be found at www.desdes.com/products/oldfiles"
          if ZEUSVER < 25
                        zeuserror "There are problems with the Spectrum emulation in this version of Zeus"
          endif
          if ZEUSVER < 11
                        zeuserror "This version of Zeus doesn't understand the DG pseudo-op"
          endif
        endif

; Build instead the compressed data for the loader

        if enabled bCompressForTape and (ZEUSVER >= 27)
                        zeuscompress $5B00,SpaceInvaders.YeEnd,Main,$5B00,1       ; This builds a block of data which you load at $5B00 and then call at $5B00, (the 1 means flash border during decompression)
                        output_bin OutputDir+"\fp_load.bin",$5B00,$6500           ; The loader data - you might need to change the size of this file
                        zeusprinthex "You need to save the block starting at $5B00 and call it at $5B00. Highest required byte's address stored at $5B02"
                        zeusprint ""
                        zeusprint "NOTE! Compressing the file can take quite a few seconds after assembly ends"
                        zeusprint ""
        else
                        zeusprinthex "( To include the joke invaders game any loading scheme must preserve up to address ",SpaceInvaders.YeEnd,"the loader should call ",Main,"to start )"
        endif

