; Spectrum equates
;
; This file is messy, I've had to recreate it from a disassembly of the game
;

ScreenBase      equ $4000                       ;
Attrs           equ $5800                       ;
lAttrs          equ $300                        ;

; Emulator interface

ScoreReportAddr         equ $FFFD               ; Binary score here
ScoreReportVector       equ $FFFF               ; We execute here to flag the score to the emulator

; Front end source starts

nOptions        equ 3                           ;

MessWait        equ 4000                        ;

; General equates

CodeFlashRate   equ 100                         ;

ArrowPos1       equ $4004
ArrowPos2       equ $50BF

GameRunning     equ 0                           ;
GameFinished    equ 1                           ;
GameQuit        equ 2                           ;

ModeDemo        equ 1                           ;

; Maximum number of objects

nObjes          equ 18                          ;

; Maximum number of lines

nLines          equ 200                         ;

; Maximum number of stars (stars are surprisingly expensive)

nStars          equ 25                          ;

; Object flag byte bits

bOnScreen       equ 0                           ;
bKilled         equ 1                           ;
bRepeat         equ 2                           ;
bCursorClip     equ 3                           ;
bScreenClip     equ 4                           ;
bSlug           equ 5                           ;
bFake           equ 6                           ;

; Those bits as masks

bbSetWind       equ $01                         ;
bbKilled        equ $02                         ;
bbRepeat        equ $04                         ;
bbCursorClip    equ $08                         ;
bbScreenClip    equ $10                         ;
bbSlug          equ $20                         ;
bbFake          equ $40                         ;

; Another flag byte's bits

bClipCent       equ 0                           ;
bbClipCent      equ $01                         ;
bbClipBelow     equ $02                         ;

MinZ            equ $01A0                       ;

; Scores for objects shot

HoleScore       equ 1                           ;
MissScore       equ 1                           ;
TowerScore      equ 1                           ;

; Damage added on impact with objects

FuelDam         equ 6                           ;
TowerDam        equ -12                         ;

SoundPort       equ $FE                         ;

nCodes          equ 16                          ;
CodesX          equ 160                         ;
CodesXc         equ 255-(6*5)                   ;

MapoY           equ 3                           ;
MapoX           equ 16                          ;

MapFlashRate    equ 200                         ;
CodeUpdateRate  equ 100                         ;

; Object types

tFHoleS         equ $00                         ;
tFHoleM         equ $01                         ;
tFHoleL         equ $02                         ;
tIris           equ $09                         ;
tMiss           equ $10                         ;
tMissA          equ $11                         ;
tProj           equ $14                         ;
tSAMs           equ $15                         ;
tSAMm           equ $16                         ;
tSAMf           equ $17                         ;
tSAMas          equ $18                         ;
tSAMss          equ $1B                         ;
tMine           equ $1C                         ;
tBunker         equ $1D                         ;
tCodeXmit       equ $1E                         ;
tCodeXmit1      equ $1E                         ;
tSAMSqu         equ $1F                         ;
tTowerS         equ $20                         ;
tTowerM         equ $21                         ;
tTowerL         equ $22                         ;
tSquMiss        equ $23                         ;
tRising         equ $24                         ;
tFuel           equ $25                         ;
tWarp           equ $26                         ;

; Player movement equates

Zdvacc          equ -10                         ;
Zdvdec          equ 10                          ;

dDX             equ 2                           ;
dDY             equ 2                           ;

Xdtstep         equ 2                           ;
Ydtstep         equ 2                           ;

StartY          equ $02BC                       ;
StartZ          equ $FFCB                       ;

MinSP           equ -52                         ;
MaxSP           equ -500                        ;
ProjSP          equ 620                         ;

HighY           equ 17000                       ;
LowY            equ 100                         ;

DamFSD          equ 71                          ;

; Offsets to fields in an object
; ie the NN values used in (ix+NN) addressing modes

        struct
dpnObje         ds 2
dppObje         ds 2
dpnFreeObje     ds 2
dObjeX          ds 2
dObjeY          ds 2
dObjeZ          ds 2
dObjedX         ds 2
dObjedY         ds 2
dObjedZ         ds 2
dObjeOX         ds 2
dObjeOY         ds 2
dObjeOZ         ds 2
dObjeDispXL     ds 2
dObjeDispXR     ds 2
dObjeDispYT     ds 2
dObjeDispYB     ds 2
dObjepLines     ds 2*8          ; There are 8 line pointers, each 16-bits
dObjepDraw      ds 1
dObjepUnDraw    ds 1
dObjeDraw       ds 2
dObjeShot       ds 2
dObjeColl       ds 2
dObjeMiss       ds 2
dObjeAlter      ds 2
dObjeMove       ds 2
dObjeFlags      ds 1
dObjeStateF     ds 1
dObjeStarComp   ds 1
dObjeAXS        ds 2
dObjeAYS        ds 2
dObjepSizeTab   ds 2
dObjeCnt        ds 1
dObjeBdXS       ds 2
dObjeBdYS       ds 2
dObjeBXS        ds 2
dObjeBYS        ds 2
dObjeWindF      ds 1
dObjeCol        ds 1
dObjeCntA       ds 1
dObjeCntiA      ds 1
dObjeCntB       ds 1
dObjeCntiB      ds 1
dObjeWidthX     ds 1
dObjeWidthY     ds 1
dObjeClipFlags  ds 1
dObjeWeapon     ds 1

        ; These variables overlap the line pointers

dObjeFFH1       equ dObjepLines+2
dObjeFFH2       equ dObjepLines+4
dObjeFFV1       equ dObjepLines+6
dObjeFFV2       equ dObjepLines+8

lObje   send

; Offsets to fields in a star

        struct
dpnStar         ds 2                            ;
dpnStarFree     ds 2                            ;
dStarX          ds 2                            ;
dStarY          ds 2                            ;
dStarZ          ds 2                            ;
dStarAddr       ds 2                            ;
dStarBit        ds 1                            ;
dStarFlag       ds 1                            ;

lStar   send                                    ;

; Offsets to fields in a list of objects

        struct
dL_pList        ds 2                            ;
dL_Z            ds 2                            ;
        send

; Offsets to an entry in a list of objects

        struct
dOL_Type        ds 1                            ;
dOL_X           ds 2                            ;
dOL_Y           ds 2                            ;
dOL_Z           ds 2                            ;
dOL_ListFlag    ds 1                            ;

lList   send                                    ;

; Offsets to the demonstration data

        struct
dDemoText       ds 2                            ;
dDemoObje       ds 2                            ;
        send

; Offsets to a line object

        struct
dpLineAlg       ds 2                            ;
dpnLine         ds 2                            ;
dpnLineFree     ds 2                            ;
dLineA          ds 1                            ;
dLineB          ds 1                            ;
dLineC          ds 1                            ;
dLineD          ds 1                            ;
dLineE          ds 1                            ;
dLineL          ds 1                            ;
dLineH          ds 1                            ;
dLineA1         ds 1                            ;
dLineC1         ds 1                            ;
dLineE1         ds 1                            ;
dLineL1         ds 1                            ;
dLineH1         ds 1                            ;
dLineSxx        ds 1                            ;
dLineBit        ds 1                            ;
dLineSyy        ds 1                            ;
dLineHV         ds 1                            ;
dLineIX         ds 2                            ;

lLine   send                                    ;

; Offsets to a tunnel (wormhole) definition

        struct
dTunnelPos1     ds 2                            ;
dTunnelAngle1   ds 1                            ;
dTunnelPos2     ds 2                            ;
dTunnelAngle2   ds 1                            ;
        send

; Offsets to a window object

        struct
dWindZ          ds 2                            ; Was 3??
dWindL          ds 2                            ;
dWindR          ds 2                            ;
dWindU          ds 2                            ;
dWindD          ds 2                            ;

lWind   send                                    ;

; Equates for the hidden rhino hunt game

        struct
dRhinoSpeed     ds 1                            ;
dRhinoiSpeed    ds 1                            ;
dRhinoPos       ds 2                            ;
dRhinoFlag      ds 1                            ;

lRhino  send                                    ;

RhinoMap        equ $6700                       ;
RhinoList       equ $6800                       ;

; Characters used in rhino hunt

cRhinoTree      equ $13                         ;
cRhinoBlank     equ $14                         ;
cRhinoChar      equ $17                         ;
cRhinoMan       equ $15                         ;
cRhinoExit      equ $16                         ;
cRhinoFuel      equ $0D                         ;

