; Start of subs

Options_Subs    ld a,(BType)                    ;
                ld b,a                          ;

                bit 0,b                         ;
                call GetSoundFlag               ;
                ld (SoundFlagHLX),a             ;

                bit 1,b                         ;
                call GetSoundFlag               ;
                ld (SoundFlagVL),a              ;

                bit 2,b                         ;
                call GetSoundFlag               ;
                ld (SoundFlagAL),a              ;
                ld (SoundFlagAL1),a             ;

                xor a                           ;
                ld (cSoundVal),a                ;
                ret                             ;

GetSoundFlag    ld a,0                          ;
                ret z                           ;

                ld a,$F8                        ;
                ret                             ;

        if not enabled Original
; If this is -1, ie, we are on the easy level, ignore damage unless we are firing

DoDamage        ld a,b                          ; If not -1 then do it
                cp -1                           ;
                jr nz AlwaysDoDamage            ;

                ; This is the smallest amount possible, easy level

                call kFire                      ; Are we firing?
                jr z DDx                        ; No, ignore this

                ; We are firing, so allow damage

                ld b,-1                         ; Do it

        ; Given a +- amount of damage in B, add it to the damage.
        else
DoDamage        equ *
        endif

AlwaysDoDamage  ld a,(DDamage)                  ;
                bit 7,b                         ;
                jr nz,DDa                       ;

                add a,b                         ;
                cp DamFSD                       ;
                jr c,DD1                        ;

                ld a,DamFSD                     ;

DD1             ld (DDamage),a                  ;
DDx             ret                             ;

DDa             add a,b                         ;
                jp p,DD1                        ;

                xor a                           ;
                jr DD1                          ;

AddScore        ld hl,(DScore)                  ;
                add a,l                         ;
                daa                             ;
                ld l,a                          ;

                ld a,h                          ;
                adc a,$00                       ;
                daa                             ;
                ld h,a                          ;

                jr nc,AS1                       ;

                ld hl,$9999                     ;

AS1             ld (DScore),hl                  ;
                ret                             ;

SubScore        ret                             ;

LimitStarCnt    ld b,a                          ;
                ld a,(cnStars)                  ;
                add a,b                         ;
                cp $1A                          ;
                ret nc                          ;

                ld (cnStars),a                  ;
                ret                             ;

ShowObje        ld hl,$0000                     ;
                ld (cObjeZ),hl                  ;

                xor a                           ;
                ld (ShuffledF),a                ;
                ld (cnObje),a                   ;

                ld iy,ObjeSeq                   ;

                ld hl,(pObjeList)               ;

SOlp            ld a,l                          ;
                or h                            ;
                jp z,ShowObje2                  ;

                ld (iy+2),l                     ;
                ld (iy+3),h                     ;

                push hl                         ;
                pop ix                          ;

                bit bKilled,(ix+dObjeFlags)     ;
                jp nz,SOMiss                    ;

                ld de,(ix+dObjedX)              ;
                ld hl,(DeltaX)                  ;
                add hl,de                       ;
                ld de,(ix+dObjeX)               ;
                ld (ix+dObjeOX),de              ;
                add hl,de                       ;
                ld (ix+dObjeX),hl               ;

                ld de,(ix+dObjedY)              ;
                ld hl,(DeltaY)                  ;
                add hl,de                       ;
                ld de,(ix+dObjeY)               ;
                ld (ix+dObjeOY),de              ;
                add hl,de                       ;
                ld (ix+dObjeY),hl               ;

                ld de,(ix+dObjedZ)              ;
                ld hl,(DeltaZ)                  ;
                add hl,de                       ;
                ld de,(ix+dObjeZ)               ;
                ld (ix+dObjeOZ),de              ;
                add hl,de                       ;
                ld (ix+dObjeZ),hl               ;

                bit 7,h                         ;
                jp nz,SOkill                    ;

                ld de,MinZ                      ;
                or a                            ;
                sbc hl,de                       ;
                jp m,SOkill                     ;

                ld de,$8000                     ;
                add hl,de                       ;

                ld (iy),l                       ;
                ld (iy+1),h                     ;

Test            ld de,(cObjeZ)                  ;
                ld (cObjeZ),hl                  ;

                or a                            ;
                sbc hl,de                       ;

                call c,SortObje                 ;

                ld bc,4                         ;
                add iy,bc                       ;

                ld a,(cnObje)                   ;
                inc a                           ;
                ld (cnObje),a                   ;

                ld hl,(ix+dpnObje)              ;
                jp SOlp                         ;

SOkill          ld a,(ix+dObjeFlags)            ;
                bit bCursorClip,a               ;
                jr nz,SOCurClip                 ;

                bit bScreenClip,a               ;
                jp z,SOMiss                     ;

                bit bOnScreen,a                 ;
                jr nz,SOHit                     ;

                ld hl,(ix+dObjeDispXL)          ;
                ld de,-128                      ;
                add hl,de                       ;
                bit 7,h                         ;
                jp p,SOMiss                     ;

                ; For some reason we call kLeft here. I think this was an editing mistake
                ; in the original source <grin>

        if enabled Original
                call kLeft                      ;
        endif

                ld hl,(ix+dObjeDispYT)          ;
                add hl,de                       ;
                bit 7,h                         ;
                jp p,SOMiss                     ;

                ld hl,(ix+dObjeDispXR)          ;
                ld de,128                       ;
                add hl,de                       ;
                bit 7,h                         ;
                jp m,SOMiss                     ;

                ld hl,(ix+dObjeDispYB)          ;
                add hl,de                       ;
                bit 7,h                         ;
                jp m,SOMiss                     ;

                jp SOHit                        ;

SOCurClip       ld hl,(ix+dObjeDispXL)          ;
                ld de,(XTurn)                   ;

                sra d                           ;
                rr e                            ;

                or a                            ;
                sbc hl,de                       ;
                jp p,SOMiss                     ;

                ld hl,(ix+dObjeDispXR)          ;
                or a                            ;
                sbc hl,de                       ;
                jp m,SOMiss                     ;

                ld hl,(ix+dObjeDispYT)          ;
                ld de,(YTurn)                   ;

                sra d                           ;
                rr e                            ;

                or a                            ;
                sbc hl,de                       ;
                jp p,SOMiss                     ;

                ld hl,(ix+dObjeDispYB)          ;
                or a                            ;
                sbc hl,de                       ;
                jp m,SOMiss                     ;

SOHit           ld hl,(ix+dObjeColl)            ;
                jp SO_k1                        ;

SOMiss          ld hl,(ix+dObjeMiss)            ;

SO_k1           call CallHL                     ;

                ld hl,(ix+dpnObje)              ;

                push iy                         ;
                push hl                         ;

                call KillObje                   ;

                pop hl                          ;
                pop iy                          ;

                ld a,(ix+dObjeStarComp)         ;
                call LimitStarCnt               ;

                jp SOlp                         ;

ShowObje2       ld a,0                          ;
ShuffledF       equ .-1                         ;

                or a                            ;

                call nz,ResortObje              ;

                ld hl,WindowTable               ;
                ld (pcWindow),hl                ;

                ld hl,$7FFF                     ;
                ld (WindowTable),hl             ;

                call ResMargin                  ;

                ld a,$FF                        ;
                ld (WindowMask),a               ;

                ld hl,(pObjeList)               ;

SOlp2           ld a,l                          ;
                or h                            ;
                ret z                           ;

                push hl                         ;
                pop ix                          ;

                ld hl,(ix+dObjeAlter)           ;
                call CallHL                     ;

                ld hl,(ix+dObjeMove)            ;
                call CallHL                     ;

                res bOnScreen,(ix+dObjeFlags)   ;

                ld a,(WindowMask)               ;
                and (ix+dObjeCol)               ;
                ld (Colour),a                   ;

                ld hl,(ix+dObjeDraw)            ;
                call CallHL                     ;

                ld hl,(ix+dpnObje)              ;
                jp SOlp2                        ;

CallDE          push de                         ;

Ret0            ret                             ;

CallHL          jp (hl)                         ;

ResortObje      ld iy,ObjeSeq                   ;

                ld b,0                          ;
cnObje          equ .-1                         ;

                ld de,0                         ;

                ld l,(iy+2)                     ;
                ld h,(iy+3)                     ;

                ld (pObjeList),hl               ;

ROlp            inc iy                          ;
                inc iy                          ;
                inc iy                          ;
                inc iy                          ;

                push hl                         ;
                pop ix                          ;

                ld (ix+dppObje),de              ;

                ex de,hl                        ;

                ld l,(iy+2)                     ;
                ld h,(iy+3)                     ;
                ld (ix+dpnObje),hl              ;

                djnz ROlp                       ;

                ld hl,0                         ;
                ld (ix+dpnObje),hl              ;

                ret                             ;

SortObje        ld a,$38                        ;
                ld (ShuffledF),a                ;

                ld e,(iy)                       ;
                ld d,(iy+1)                     ;

                push ix                         ;

                ld ix,ObjeSeq-4                 ;

                ld bc,4                         ;

SortLp          add ix,bc                       ;

                ld l,(ix)                       ;
                ld h,(ix+1)                     ;
                or a                            ;
                sbc hl,de                       ;
                jp m,SortLp                     ;

                ld a,(cnObje)                   ;
                add a,a                         ;
                add a,a                         ;
                add a,4                         ;
                ld c,a                          ;
                ld b,0                          ;

                push ix                         ;
                pop hl                          ;

                add hl,bc                       ;

                ld d,h                          ;
                ld e,l                          ;

                inc de                          ;
                inc de                          ;
                inc de                          ;
                inc de                          ;

                lddr                            ;

                ld l,(iy+4)                     ;
                ld h,(iy+5)                     ;
                ld (ix),l                       ;
                ld (ix+1),h                     ;

                ld l,(iy+6)                     ;
                ld h,(iy+7)                     ;
                ld (ix+2),l                     ;
                ld (ix+3),h                     ;

                pop ix                          ;
                ret                             ;

FFgetline       ld iy,(pFreeLines)              ;
                ld a,iyl                        ;
                or iyh                          ;
                scf                             ;
                ret z                           ;

                ld hl,(iy+dpnLineFree)          ;
                ld (pFreeLines),hl              ;

                ld hl,0                         ;
                ld (iy+dpnLine),hl              ;

                ld hl,Ret02                     ;
                ld (iy+dpLineAlg),hl            ;

                or a                            ; And as well as that there are scoping issues
                ret                             ; when the sources were combined, so several Ret's clashed.

AddFirstLine    ld iy,(pFreeLines)              ;
                ld a,iyl                        ;
                or iyh                          ;
                scf                             ;
                ret z                           ;

                ld hl,(iy+dpnLineFree)          ;
                ld (pFreeLines),hl              ;

                ld hl,0                         ;
                ld (iy+dpnLine),hl              ;

                ld hl,Ret02                     ;
                ld (iy+dpLineAlg),hl            ;

                ld a,(ix+dObjepDraw)            ;
                inc a                           ;
                and $07                         ;
                ld (ix+dObjepDraw),a            ;

                add a,a                         ;
                add a,dObjepLines               ;
                add a,ixl                       ;
                ld l,a                          ;

                ld a,ixh                        ;
                adc a,0                         ;
                ld h,a                          ;

                ld a,iyl                        ;
                ld (hl),a                       ;
                inc hl                          ;
                ld a,iyh                        ;
                ld (hl),a                       ;

                or a                            ;
                ret                             ;

AddLine         ld hl,(pFreeLines)              ;
                ld (iy+dpnLine),hl              ;

                ld a,l                          ;
                or h                            ;
                scf                             ;
                ret z                           ;

                push hl                         ;
                pop iy                          ;

                ld hl,(iy+dpnLineFree)          ;
                ld (pFreeLines),hl              ;

                ld hl,0                         ;
                ld (iy+dpnLine),hl              ;

                ld hl,Ret02                     ;
                ld (iy+dpLineAlg),hl            ;

                ret                             ;

UndrawLines     ld a,(ix+dObjepUnDraw)          ;
                inc a                           ;
                and $07                         ;
                ld (ix+dObjepUnDraw),a          ;

                add a,a                         ;
                add a,dObjepLines               ;
                add a,ixl                       ;
                ld l,a                          ;

                ld b,$00                        ;

                ld a,ixh                        ;
                adc a,b                         ;
                ld h,a                          ;

                ld a,(hl)                       ;
                ld (hl),b                       ;
                inc hl                          ;
                ld c,(hl)                       ;
                ld (hl),b                       ;
                ld h,c                          ;
                ld l,a                          ;

Undrawlp        ld a,l                          ;
                or h                            ;
                ret z                           ;

                push hl                         ;
                pop iy                          ;

                ld hl,(iy+dpLineAlg)            ;
                call CallHL                     ;

                ld hl,(pFreeLines)              ;
                ld (iy+dpnLineFree),hl          ;
                ld (pFreeLines),iy              ;

                ld hl,(iy+dpnLine)              ;

                jp Undrawlp                     ;

InitObjes       ld hl,ObjeTable                 ;
                ld (pFreeObje),hl               ;

                ld b,nObjes                     ;
                ld de,lObje                     ;

IOlp            push hl                         ;
                pop ix                          ;

                add hl,de                       ;

                ld (ix+dpnFreeObje),hl          ;

                djnz IOlp                       ;

                ld hl,0                         ;
                ld (ix+dpnFreeObje),hl          ;

                ld (pObjeList),hl               ;

                ret                             ;

InitLines       ld hl,LineTable                 ;
                ld (pFreeLines),hl              ;

                ld b,nLines                     ;

                ld de,lLine                     ;

ILlp            push hl                         ;
                pop ix                          ;

                add hl,de                       ;

                ld (ix+dpnLineFree),hl          ;

                djnz ILlp                       ;

                ld hl,0                         ;
                ld (ix+dpnLineFree),hl          ;

                ret                             ;

AddObje         ex de,hl                        ;

                ld iy,(pFreeObje)               ;
                ld a,iyl                        ;
                or iyh                          ;
                scf                             ;
                ret z                           ;

                ld hl,(iy+dpnFreeObje)          ;
                ld (pFreeObje),hl               ;

                ld hl,(pObjeList)               ;

                ld a,l                          ;
                or h                            ;
                jr nz,AOnz                      ;

                ld (iy+dppObje),hl              ;
                ld (iy+dpnObje),hl              ;

                ld (pObjeList),iy               ;

                ex de,hl                        ;
                ld (iy+dObjeZ),hl               ;

                or a                            ;
                ret                             ;

AOlast          ld (iy+dpnObje),hl              ;

                push ix                         ;
                pop hl                          ;

                ld (iy+dppObje),hl              ;

                push iy                         ;
                pop hl                          ;

                ld (ix+dpnObje),hl              ;

                ex de,hl                        ;
                ld (iy+dObjeZ),hl               ;

                or a                            ;
                ret                             ;

AOnxt           ld hl,(ix+dpnObje)              ;

                ld a,l                          ;
                or h                            ;
                jr z,AOlast                     ;

AOnz            push hl                         ;
                pop ix                          ;

                ld hl,(ix+dObjeZ)               ;
                or a                            ;
                sbc hl,de                       ;
                jp m,AOnxt                      ;

                ld hl,(ix+dppObje)              ;
                ld (iy+dppObje),hl              ;

                push iy                         ;
                pop bc                          ;

                ld (ix+dppObje),bc              ;

                push ix                         ;
                push hl                         ;
                pop ix                          ;
                pop hl                          ;

                ld (iy+dpnObje),hl              ;

                ld a,ixh                        ;
                or ixl                          ;
                jr z,AOb                        ;

                ld (ix+dpnObje),bc              ;

                ex de,hl                        ;
                ld (iy+dObjeZ),hl               ;

                or a                            ;
                ret                             ;

AOb             ld hl,0                         ;
                ld (iy+dppObje),hl              ;

                ld (pObjeList),iy               ;

                ex de,hl                        ;
                ld (iy+dObjeZ),hl               ;

                or a                            ;
                ret                             ;

KillObje        ld de,dObjepLines               ;

                push ix                         ;
                pop iy                          ;

                add iy,de                       ;

                ld b,8                          ;

KOlines         push iy                         ;
                push bc                         ;

                ld l,(iy)                       ;
                ld h,(iy+1)                     ;
                call Undrawlp                   ;

                pop bc                          ;
                pop iy                          ;

                inc iy                          ;
                inc iy                          ;

                djnz KOlines                    ;

                ld hl,(ix+dppObje)              ;
                ld a,l                          ;
                or h                            ;
                jr z,KOz                        ;

                push hl                         ;
                pop iy                          ;

                ld de,(ix+dpnObje)              ;
                ld (iy+dpnObje),de              ;

                push de                         ;
                pop iy                          ;

                ld (iy+dppObje),hl              ;

KOx             ld hl,(pFreeObje)               ;
                ld (ix+dpnFreeObje),hl          ;

                ld (pFreeObje),ix               ;
                ret                             ;

KOz             ld de,(ix+dpnObje)              ;
                ld (pObjeList),de               ;

                push de                         ;
                pop iy                          ;

                ld (iy+dppObje),hl              ;

                jp KOx                          ;

InitVectAdd     ld hl,(DeltaX)                  ;

                ld a,h                          ;
                ld (vaXh),a                     ;

                ld a,l                          ;
                ld (vaXl),a                     ;

                ld hl,(DeltaY)                  ;

                ld a,h                          ;
                ld (vaYh),a                     ;

                ld a,l                          ;
                ld (vaY1),a                     ;

                ld hl,(DeltaZ)                  ;

                ld a,h                          ;
                ld (vaZh),a                     ;

                ld a,l                          ;
                ld (vaZl),a                     ;

                ret                             ;

DoVectAdd       ld a,(hl)                       ;
                add a,0                         ;
vaXl            equ .-1                         ;
                ld (hl),a                       ;
                inc hl                          ;
                ld a,(hl)                       ;
                adc a,0                         ;
vaXh            equ .-1                         ;
                ld (hl),a                       ;
                inc hl                          ;

                ld a,(hl)                       ;
                add a,0                         ;
vaY1            equ .-1                         ;
                ld (hl),a                       ;
                inc hl                          ;
                ld a,(hl)                       ;
                adc a,0                         ;
vaYh            equ .-1                         ;
                ld (hl),a                       ;
                inc hl                          ;

                ld a,(hl)                       ;
                add a,0                         ;
vaZl            equ .-1                         ;
                ld (hl),a                       ;
                inc hl                          ;
                ld a,(hl)                       ;
                adc a,0                         ;
vaZh            equ .-1                         ;
                ld (hl),a                       ;

                ret                             ;

DoVectors       ld hl,(GroundX)                 ;
                ld de,(DeltaX)                  ;
                add hl,de                       ;
                ld (GroundX),hl                 ;

                ld hl,(GroundY)                 ;
                ld de,(DeltaY)                  ;
                add hl,de                       ;
                ld (GroundY),hl                 ;

                ld hl,(GroundZ)                 ;
                ld de,(DeltaZ)                  ;
                add hl,de                       ;
                ld (GroundZ),hl                 ;

                ret                             ;

ResMargin       ld hl,-127                      ;
                ld (MinX),hl                    ;
                ld (nMinX),hl                   ;
                ld (TopY),hl                    ;
                ld (nTopY),hl                   ;

                ld hl,127                       ;
                ld (MaxX),hl                    ;
                ld (BotY),hl                    ;

                ld hl,0                         ;
                ld (AMinX),hl                   ;
                ld (ATopY),hl                   ;

                ld hl,256                       ;
                ld (AMaxX),hl                   ;
                ld (ABotY),hl                   ;

                ret                             ;

SetRMargin      push hl                         ;
                push de                         ;

                ld de,(MaxX)                    ;
                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                jp p,SRMx                       ;

                ld de,128                       ;
                ld (MaxX),hl                    ;

                add hl,de                       ;
                ld (AMaxX),hl                   ;

SRMx            pop de                          ;
                pop hl                          ;
                ret                             ;

SetDMargin      push hl                         ;
                push de                         ;

                ld de,(BotY)                    ;
                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                jp p,SDMx                       ;

                ld de,128                       ;
                ld (BotY),hl                    ;

                add hl,de                       ;
                ld (ABotY),hl                   ;

SDMx            pop de                          ;
                pop hl                          ;
                ret                             ;

SetLMargin      push hl                         ;
                push de                         ;

                ld de,(MinX)                    ;
                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                jp m,SLMx                       ;

                ld de,128                       ;
                ld (MinX),hl                    ;

                add hl,de                       ;
                ld (AMinX),hl                   ;
                or a                            ;
                sbc hl,de                       ;

                Neg_HL()                        ;
                ld (nMinX),hl                   ;

SLMx            pop de                          ;
                pop hl                          ;
                ret                             ;

SetUMargin      push hl                         ;
                push de                         ;

                ld de,(TopY)                    ;
                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                jp m,SUMx                       ;

                ld de,128                       ;
                ld (TopY),hl                    ;

                add hl,de                       ;
                ld (ATopY),hl                   ;
                or a                            ;
                sbc hl,de                       ;

                Neg_HL()                        ;
                ld (nTopY),hl                   ;

SUMx            pop de                          ;
                pop hl                          ;
                ret                             ;

SetUpTabs       ld hl,BitTab                    ;
                ld a,$80                        ;
GenXTab         ld (hl),a                       ;
                inc l                           ;
                rrca                            ;
                jr nc,GenXTab                   ;
                ld a,$FF                        ;
GenXTab1        ld (hl),a                       ;
                inc l                           ;
                srl a                           ;
                or a                            ;
                jr nz,GenXTab1                  ;
                ld a,$80                        ;
GenXTab2        ld (hl),a                       ;
                inc l                           ;
                sra a                           ;
                cp $FF                          ;
                jr nz,GenXTab2                  ;
                ld (hl),a                       ;
Ret02           ret                             ;

GenYTab         ld hl,YTable                    ;
                ld de,ScreenBase                ;
                ld c,24                         ;

CharLp          ld b,8                          ;

CharLp1         ld (hl),e                       ;
                inc h                           ;
                ld (hl),d                       ;
                dec h                           ;

                inc l                           ;
                inc d                           ;

                djnz CharLp1                    ;

                ld a,d                          ;
                sub 8                           ;
                ld d,a                          ;

                dec c                           ;
                jr z,GYT1                       ;

                ld a,e                          ;
                add a,32                        ;
                ld e,a                          ;

                jr nc,CharLp                    ;

                ld a,d                          ;
                add a,8                         ;
                ld d,a                          ;

                jr CharLp                       ;

GYT1            ld b,$40                        ;

GYT2            ld (hl),0                       ;
                inc h                           ;
                ld (hl),0                       ;
                dec h                           ;

                inc l                           ;

                djnz GYT2                       ;

                ret                             ;

CLS             ld a,(CType)                    ;
                ld hl,YTable+10                 ;
                ld b,156                        ;

                or a                            ;
                jr z,CLSa                       ;

                ld hl,YTable                    ;
                ld b,170                        ;

                cp 3                            ;
                jr c,CLSa                       ;

                ld hl,YTable                    ;
                ld b,192                        ;

CLSa            xor a                           ;

CLSlp           ld e,(hl)                       ;
                inc h                           ;
                ld d,(hl)                       ;
                dec h                           ;

                inc l                           ;

                push hl                         ;
                push bc                         ;

                ld h,d                          ;
                ld l,e                          ;
                inc de                          ;

                ld bc,$1F                       ;

                ld (hl),a                       ;

                ldir                            ;

                pop bc                          ;
                pop hl                          ;

                djnz CLSlp                      ;

                ld hl,$5820                     ;
                ld de,$5821                     ;
                ld bc,$27F                      ;

                ld (hl),$47                     ;
                ldir                            ;

                ret                             ;

Gen192Tab       ld bc,DivTab                    ;
                ld hl,$0D00                     ;
                ld de,$0099                     ;

                ld a,(CType)                    ;
                or a                            ;
                jr z,G192                       ;

                ld hl,$0000                     ;
                ld de,$00A7                     ; $a8 in v1.1
                cp 3                            ;
                jr c,G192                       ;

                ld hl,$0000                     ;
                ld de,191                       ;

G192            ld a,h                          ;
                ld (bc),a                       ;
                add hl,de                       ;
                inc c                           ;
                jr nz,G192                      ;

                ret                             ;

CAf             ld hl,0                         ;
                xor a                           ;

                scf                             ;
                ret                             ;

ClipAddr        ld bc,(BotY)                    ;
                or a                            ;
                sbc hl,bc                       ;
                jp p,CAf                        ;
                add hl,bc                       ;

                ld bc,(TopY)                    ;
                or a                            ;
                sbc hl,bc                       ;
                jp m,CAf                        ;
                add hl,bc                       ;

                ex de,hl                        ;

                ld bc,(MaxX)                    ;
                or a                            ;
                sbc hl,bc                       ;
                jp p,CAf                        ;
                add hl,bc                       ;

                ld bc,(MinX)                    ;
                or a                            ;
                sbc hl,bc                       ;
                jp m,CAf                        ;
                add hl,bc                       ;

                ex de,hl                        ;

CalcAddr        ld bc,128                       ;
                add hl,bc                       ;
                ex de,hl                        ;
                add hl,bc                       ;
                ex de,hl                        ;
                ld h,DivTab/256                 ;
                ld l,(hl)                       ;
                ld h,YTable/256                 ;
                ld a,(hl)                       ;
                inc h                           ;
                ld h,(hl)                       ;
                ld l,a                          ;
                ld a,e                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $1F                         ;
                or l                            ;
                ld l,a                          ;
                ld a,e                          ;
                and $07                         ;
                ld e,a                          ;
                ld d,BitTab/256                 ;
                ld a,(de)                       ;
                ret                             ;

VB1             pop hl                          ;
                scf                             ;
                ret                             ;

VertLine        push hl                         ;

                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                jp p,HS1                        ;

                push bc                         ;

                ld bc,(BotY)                    ;
                or a                            ;
                sbc hl,bc                       ;

                jp p,HS1a                       ;

                ld hl,(TopY)                    ;
                or a                            ;
                sbc hl,de                       ;

                jp p,HS1a                       ;

                pop hl                          ;

                ld bc,(MaxX)                    ;
                or a                            ;
                sbc hl,bc                       ;
                jp p,HS1                        ;
                add hl,bc                       ;

                ld bc,(MinX)                    ;
                or a                            ;
                sbc hl,bc                       ;
                jp m,HS1                        ;
                add hl,bc                       ;

                ld bc,128                       ;
                add hl,bc                       ;

                ld a,l                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $1F                         ;
                ld (V1),a                       ;

                ld a,l                          ;
                rlca                            ;
                rlca                            ;
                rlca                            ;
                cpl                             ;
                and $38                         ;
                or $C6                          ;

                ld (vm0),a                      ;
                ld (vm1),a                      ;
                ld (vm2),a                      ;
                ld (vm3),a                      ;
                ld (vm4),a                      ;
                ld (vm5),a                      ;
                ld (vm6),a                      ;
                ld (vm7),a                      ;
                ld (vm8),a                      ;
                ld (vm9),a                      ;

                and $BF                         ;
                ld (iy+dLineBit),a              ;

                pop hl                          ;

                ld bc,(TopY)                    ;
                or a                            ;
                sbc hl,bc                       ;
                add hl,bc                       ;
                jp p,VS2                        ;

                ld h,b                          ;
                ld l,c                          ;

VS2             ld bc,128                       ;
                add hl,bc                       ;

                ex de,hl                        ;

                ld bc,(BotY)                    ;
                or a                            ;
                sbc hl,bc                       ;
                add hl,bc                       ;
                jp m,VS3                        ;

                ld h,b                          ;
                ld l,c                          ;

VS3             ld bc,128                       ;
                add hl,bc                       ;

                ex de,hl                        ;

                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                ret p                           ;

                ld h,DivTab/256                 ;
                ld d,DivTab/256                 ;
                ld a,(de)                       ;
                sub (hl)                        ;
                or a                            ;
                ret z                           ;

                inc a                           ;
                ld (iy+dLineB),a                ;
                ld b,a                          ;
                ld l,(hl)                       ;
                ld h,YTable/256                 ;
                ld a,0                          ;
V1              equ .-1                         ;
                ld c,a                          ;
                add a,(hl)                      ;
                ld (iy+dLineL),a                ;
                inc h                           ;
                ld a,(hl)                       ;
                ld (iy+dLineH),a                ;
                ld a,l                          ;
                rlca                            ;
                rlca                            ;
                and $03                         ;
                or $58                          ;
                ld (iy+dLineH1),a               ;
                ld d,a                          ;
                ld a,l                          ;
                rlca                            ;
                rlca                            ;
                and $E0                         ;
                or c                            ;
                ld (iy+dLineL1),a               ;
                ld e,a                          ;
                ld a,l                          ;
                and $07                         ;
                ld l,a                          ;
                ld h,BitTab/256                 ;
                ld a,(Colour)                   ;
                ld c,a                          ;
                ld a,(hl)                       ;
                ld (iy+dLineA),a                ;
                ex de,hl                        ;
                ld de,$0020                     ;
                exx                             ;
                ld c,$1F                        ;
                ld b,(iy+dLineB)                ;
                ld l,(iy+dLineL)                ;
                ld h,(iy+dLineH)                ;
                call vl1                        ;
VS4             ld (iy+dpLineAlg),Vert10 & $FF  ;
                ld (iy+dpLineAlg+1),Vert10 / 256;

                scf                             ;
                ret                             ;

vl1             dec b                           ;
                ret z                           ;
                set 0,(hl)                      ; SMC
vm0             equ .-1                         ;
                inc h                           ;
                rrca                            ;
                jp nc,vl1                       ;
                ld a,l                          ;
                adc a,c                         ;
                ld l,a                          ;
                jr c,vl2                        ;
                ld a,h                          ;
                sub 8                           ;
                ld h,a                          ;
vl2             exx                             ;
                ld (hl),c                       ;
                add hl,de                       ;
                exx                             ;
                ld a,b                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $1F                         ;
                jr z,vl3                        ;
vl4             set 0,(hl)                      ;
vm1             equ .-1                         ;
                inc h                           ;
                set 0,(hl)                      ;
vm2             equ .-1                         ;
                inc h                           ;
                set 0,(hl)                      ;
vm3             equ .-1                         ;
                inc h                           ;
                set 0,(hl)                      ;
vm4             equ .-1                         ;
                inc h                           ;
                set 0,(hl)                      ;
vm5             equ .-1                         ;
                inc h                           ;
                set 0,(hl)                      ;
vm6             equ .-1                         ;
                inc h                           ;
                set 0,(hl)                      ;
vm7             equ .-1                         ;
                inc h                           ;
                set 0,(hl)                      ;
vm8             equ .-1                         ;
                inc h                           ;
                ex af,af'                       ;
                ld a,(cSoundVal)                ;
                xor $F8                         ;
SoundFlagVL     equ .-1                         ;

                ld (cSoundVal),a                ;
                out (SoundPort),a               ;

                ld a,l                          ;
                add a,$20                       ;
                ld l,a                          ;
                jr c,vl6                        ;
                ld a,h                          ;
                sub $08                         ;
                ld h,a                          ;
vl6             exx                             ;
                ld (hl),c                       ;
                add hl,de                       ;
                exx                             ;
                ex af,af'                       ;
                dec a                           ;
                jr nz,vl4                       ;
vl3             ld a,b                          ;
                and $07                         ;
                ret z                           ;
                ld b,a                          ;
vl5             set 0,(hl)                      ;
vm9             equ .-1                         ;
                inc h                           ;
                djnz vl5                        ;
                exx                             ;
                ld (hl),c                       ;
                exx                             ;
                ret                             ;

Vert10          ld l,(iy+dLineL1)               ;
                ld h,(iy+dLineH1)               ;
                ld de,$0020                     ;
                ld a,(GameAttr)                 ;
                ld c,a                          ;
                exx                             ;
                ld a,(iy+dLineBit)              ;
                ld (vm0),a                      ;
                ld (vm1),a                      ;
                ld (vm2),a                      ;
                ld (vm3),a                      ;
                ld (vm4),a                      ;
                ld (vm5),a                      ;
                ld (vm6),a                      ;
                ld (vm7),a                      ;
                ld (vm8),a                      ;
                ld (vm9),a                      ;
                ld a,(iy+dLineA)                ;
                ld b,(iy+dLineB)                ;
                ld l,(iy+dLineL)                ;
                ld h,(iy+dLineH)                ;
                ld c,$1F                        ;
                jp vl1                          ;

HS1a            pop bc                          ;
HS1             pop hl                          ;
                or a                            ;
                ret                             ;

HpS             defw 0                          ;
HpA             defw 0                          ;

HoriLineEx      xor a                           ;

                ld (HLsmc),a                    ;

                out (SoundPort),a               ;

                call HoriLine                   ;

                ld a,$F8                        ;
SoundFlagHLX    equ .-1                         ;

                out (SoundPort),a               ;

                ld a,$FF                        ;
                ld (HLsmc),a                    ;

                ret                             ;

HoriLine        push hl                         ;

                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                jp p,HS1                        ;

                push bc                         ;

                ld bc,(MaxX)                    ;
                or a                            ;
                sbc hl,bc                       ;

                jp p,HS1a                       ;

                ld hl,(MinX)                    ;
                or a                            ;
                sbc hl,de                       ;

                jp p,HS1a                       ;

                pop bc                          ;

                ld hl,128                       ;
                add hl,bc                       ;

                ld bc,(ABotY)                   ;
                or a                            ;
                sbc hl,bc                       ;
                jp p,HS1                        ;
                add hl,bc                       ;

                ld bc,(ATopY)                   ;
                or a                            ;
                sbc hl,bc                       ;
                jp m,HS1                        ;
                add hl,bc                       ;

                ld h,DivTab/256                 ;
                ld l,(hl)                       ;

                ld h,YTable/256                 ;

                ld c,(hl)                       ;
                inc h                           ;
                ld b,(hl)                       ;

                ld (HpS),bc                     ;

                ld (iy+dLineH),b                ;

                ld a,l                          ;
                rlca                            ;
                rlca                            ;
                and $03                         ;
                or $58                          ;
                ld h,a                          ;

                ld a,l                          ;
                rlca                            ;
                rlca                            ;
                and $E0                         ;
                ld l,a                          ;
                ld (HpA),hl                     ;
                ld (iy+dLineD),h                ;

                pop hl                          ;

                ld bc,(MinX)                    ;
                or a                            ;
                sbc hl,bc                       ;
                add hl,bc                       ;
                jp p,HS2                        ;

                ld h,b                          ;
                ld l,c                          ;

HS2             ld bc,128                       ;
                add hl,bc                       ;

                ex de,hl                        ;

                ld bc,(MaxX)                    ;
                or a                            ;
                sbc hl,bc                       ;
                add hl,bc                       ;
                jp m,HS3                        ;

                ld h,b                          ;
                ld l,c                          ;

HS3             ld bc,128                       ;
                add hl,bc                       ;

                ex de,hl                        ;
                or a                            ;
                sbc hl,de                       ;
                add hl,de                       ;

                ret p                           ;

                ld a,e                          ;
                sub l                           ;
                or a                            ;
                ret z                           ;

                ld a,l                          ;
                and $07                         ;
                add a,8                         ;
                ld c,a                          ;
                ld b,BitTab/256                 ;
                ld a,(bc)                       ;
                ld (iy+dLineA),a                ;
                ld a,e                          ;
                and $07                         ;
                add a,16                        ;
                ld c,a                          ;
                ld a,(bc)                       ;
                ld (iy+dLineA1),a               ;
                ld a,l                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $1F                         ;
                ld l,a                          ;
                ld a,e                          ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $1F                         ;
                ld e,a                          ;
                ld a,(HpS)                      ;
                or l                            ;
                ld (HpS),a                      ;
                ld (iy+dLineL),a                ;
                ld a,(HpA)                      ;
                or l                            ;
                ld (HpA),a                      ;
                ld (iy+dLineE),a                ;
                ld a,e                          ;
                sub l                           ;
                jr z,HS4                        ;
                ld (iy+dLineB),a                ;
                ld hl,(HpS)                     ;
                ld de,(HpA)                     ;
                ld b,a                          ;
                ld a,(Colour)                   ;
                ld c,a                          ;
                ld a,(iy+dLineA1)               ;
                ex af,af'                       ;
                ld a,(iy+dLineA)                ;
                call HoriS                      ;
                ld (iy+dpLineAlg),HS6 & $FF     ;
                ld (iy+dpLineAlg+1),HS6 / 256   ;

                set bOnScreen,(ix+dObjeFlags)   ;

                scf                             ;
                ret                             ;

HS4             ld hl,(HpA)                     ;
                ld a,(Colour)                   ;
                ld (hl),a                       ;
                ld hl,(HpS)                     ;
                ld a,(iy+dLineA)                ;
                and (iy+dLineA1)                ;
                or (hl)                         ;
                ld (hl),a                       ;
                ld (iy+dpLineAlg),HS5 & $FF     ;
                ld (iy+dpLineAlg+1),HS5 / 256   ;

                set bOnScreen,(ix+dObjeFlags)   ;

                scf                             ;
                ret                             ;

HS5             ld l,(iy+dLineE)                ;
                ld h,(iy+dLineD)                ;

                ld a,(GameAttr)                 ;
                ld (hl),a                       ;

                ld l,(iy+dLineL)                ;
                ld h,(iy+dLineH)                ;
                ld a,(iy+dLineA)                ;
                and (iy+dLineA1)                ;
                cpl                             ;
                and (hl)                        ;
                ld (hl),a                       ;

                ret                             ;

HS6             ld l,(iy+dLineL)                ;
                ld h,(iy+dLineH)                ;

                ld e,(iy+dLineE)                ;
                ld d,(iy+dLineD)                ;

                ld b,(iy+dLineB)                ;
                ld a,(iy+dLineA1)               ;
                cpl                             ;
                ex af,af'                       ;
                ld a,(GameAttr)                 ;
                ld c,a                          ;
                ld a,(iy+dLineA)                ;
                cpl                             ;
                and (hl)                        ;
                ld (hl),a                       ;
                ld a,c                          ;
                ld (de),a                       ;
                inc l                           ;
                inc e                           ;
                djnz Hori0a                     ;
                ld (de),a                       ;
                ex af,af'                       ;
                and (hl)                        ;
                ld (hl),a                       ;
                ret                             ;

Hori0a          ld c,$00                        ;
Hori1a          ld (hl),c                       ;
                ld (de),a                       ;
                inc l                           ;
                inc e                           ;
                djnz Hori1a                     ;
                ld (de),a                       ;
                ex af,af'                       ;
                and (hl)                        ;
                ld (hl),a                       ;
                ret                             ;

HoriS           or (hl)                         ;
                ld (hl),a                       ;
                ld a,c                          ;
                ld (de),a                       ;
                inc l                           ;
                inc e                           ;
                djnz Hori0                      ;
                ld (de),a                       ;
                ex af,af'                       ;
                or (hl)                         ;
                ld (hl),a                       ;
                ret                             ;

Hori0           ld c,$FF                        ;
HLsmc           equ .-1                         ;
Hori1           ld (hl),c                       ;
                ld (de),a                       ;
                inc l                           ;
                inc e                           ;
                djnz Hori1                      ;
                ld (de),a                       ;
                ex af,af'                       ;
                or (hl)                         ;
                ld (hl),a                       ;
                ret                             ;

CalcEdges       push bc                         ;

                xor a                           ;

                ld bc,(AMaxX)                   ;

                sbc hl,bc                       ;
                add hl,bc                       ;

                jp p,CEgx                       ;

                ld bc,(AMinX)                   ;

                or a                            ;
                sbc hl,bc                       ;
                jp m,CElx                       ;
                add hl,bc                       ;

CEY             ex de,hl                        ;

                ld bc,(ABotY)                   ;
                or a                            ;
                sbc hl,bc                       ;
                add hl,bc                       ;

                jp p,CEgy                       ;

                ld bc,(ATopY)                   ;

                or a                            ;
                sbc hl,bc                       ;
                jp m,CEly                       ;
                add hl,bc                       ;

                ex de,hl                        ;

                pop bc                          ;
                ret                             ;

CEgx            or $02                          ;
                jp CEY                          ;

CElx            or $01                          ;
                add hl,bc                       ;
                jp CEY                          ;

CEgy            or $04                          ;
                ex de,hl                        ;
                pop bc                          ;
                ret                             ;

CEly            or $08                          ;
                add hl,bc                       ;
                ex de,hl                        ;
                pop bc                          ;
                ret                             ;

ClipThing       ld bc,128                       ;
                add hl,bc                       ;
                ld (ctX2),hl                    ;
                ex de,hl                        ;
                add hl,bc                       ;
                ld (ctX1),hl                    ;
                exx                             ;
                ld bc,128                       ;
                add hl,bc                       ;
                ld (ctY2),hl                    ;
                ex de,hl                        ;
                add hl,bc                       ;
                ld (ctY1),hl                    ;
                ld hl,0                         ;
ctX1            equ .-2                         ;
                ld de,0                         ;
ctY1            equ .-2                         ;
                call CalcEdges                  ;
                ld b,a                          ;
                ld hl,0                         ;
ctX2            equ .-2                         ;
                ld de,0                         ;
ctY2            equ .-2                         ;
                call CalcEdges                  ;
                ld c,a                          ;
                or b                            ;
                ret z                           ;
                ld a,c                          ;
                and b                           ;
                scf                             ;
                ret nz                          ;
                ld hl,(ctX1)                    ;
                ld (PaX),hl                     ;
                ld hl,(ctY1)                    ;
                ld (PaY),hl                     ;
                ld hl,(ctX2)                    ;
                ld (PbX),hl                     ;
                ld hl,(ctY2)                    ;
                ld (PbY),hl                     ;
                call ClipInner                  ;
                ret c                           ;
                ld hl,(PaX)                     ;
                ld (ctX2),hl                    ;
                ld hl,(PaY)                     ;
                ld (ctY2),hl                    ;
                ld hl,(ctX1)                    ;
                ld (PbX),hl                     ;
                ld hl,(ctY1)                    ;
                ld (PbY),hl                     ;
                call ClipInner                  ;
                ret c                           ;
                ld hl,(PaX)                     ;
                ld (ctX1),hl                    ;
                ld hl,(PaY)                     ;
                ld (ctY1),hl                    ;
                or a                            ;
                ret                             ;

ClipInner       ld hl,0                         ;
PbX             equ .-2                         ;
                ld de,0                         ;
PbY             equ .-2                         ;
                ld (PmX),hl                     ;
                ld (PmY),de                     ;
                call CalcEdges                  ;
                or a                            ;
                jr nz,C2                        ;
                ld (PaX),hl                     ;
                ld (PaY),de                     ;
                ret                             ;

C2              ld hl,0                         ;
PaX             equ .-2                         ;
                ld de,0                         ;
PaY             equ .-2                         ;
                call CalcEdges                  ;
                ld b,a                          ;
                ld hl,0                         ;
PmX             equ .-2                         ;
                ld de,0                         ;
PmY             equ .-2                         ;
                call CalcEdges                  ;
                and b                           ;
                scf                             ;
                ret nz                          ;
                ld hl,(PmX)                     ;
                ld de,(PaX)                     ;
                or a                            ;
                sbc hl,de                       ;
                sra h                           ;
                rr l                            ;
                ld de,(PaX)                     ;
                add hl,de                       ;
                ld (PmX),hl                     ;
                ld hl,(PmY)                     ;
                ld de,(PaY)                     ;
                or a                            ;
                sbc hl,de                       ;
                sra h                           ;
                rr l                            ;
                ld de,(PaY)                     ;
                add hl,de                       ;
                ld (PmY),hl                     ;
                call TestPm                     ;
                ret z                           ;
                ld hl,(PbX)                     ;
                ld de,(PbY)                     ;
                call CalcEdges                  ;
                ld b,a                          ;
                ld hl,(PmX)                     ;
                ld de,(PmY)                     ;
                call CalcEdges                  ;
                and b                           ;
                jr z,C4a                        ;
                ld (PbX),hl                     ;
                ld (PbY),de                     ;
                jp C2                           ;

C4a             ld (PaX),hl                     ;
                ld (PaY),de                     ;
                ld hl,(PbX)                     ;
                ld de,(PbY)                     ;
                ld (PmX),hl                     ;
                ld (PmY),de                     ;
                jp C2                           ;

TestPm          ld hl,(PmX)                     ;
                ld de,(PaX)                     ;
                or a                            ;
                sbc hl,de                       ;
                jr nz,TPm1                      ;
                ld hl,(PmY)                     ;
                ld de,(PaY)                     ;
                or a                            ;
                sbc hl,de                       ;
                ret z                           ;
TPm1            ld hl,(PmX)                     ;
                ld de,(PbX)                     ;
                or a                            ;
                sbc hl,de                       ;
                ret nz                          ;
                ld hl,(PmY)                     ;
                ld de,(PbY)                     ;
                or a                            ;
                sbc hl,de                       ;
                ret                             ;

ALOld           push ix                         ;
                ld a,(iy+dLineSxx)              ;
                ld (OAxx),a                     ;
                ld a,(iy+dLineSyy)              ;
                ld (OAyy),a                     ;
                ld a,(iy+dLineHV)               ;
                ld (OAHV),a                     ;
                ld hl,(iy+dLineIX)              ;
                push hl                         ;
                pop ix                          ;
                ld c,(iy+dLineC1)               ;
                ld e,(iy+dLineE1)               ;
                ld l,(iy+dLineL1)               ;
                exx                             ;
                ld b,(iy+dLineB)                ;
                ld c,(iy+dLineC)                ;
                ld e,(iy+dLineE)                ;
                ld l,(iy+dLineL)                ;
                ld h,(iy+dLineH)                ;
                ld a,(GameAttr)                 ;
                ld d,a                          ;
                ld a,(hl)                       ;
OA1             cpl                             ;
                or c                            ;
                cpl                             ;
                exx                             ;
                ex af,af'                       ;
                ld a,l                          ;
                sub e                           ;
                jr c,OA3                        ;
                ld l,a                          ;
                exx                             ;
                ex af,af'                       ;
                call Incxx                      ;
OAHV            equ .-2                         ;
                djnz OA1                        ;
                ld (hl),a                       ;
OA3x            ld a,c                          ;
                and e                           ;
                jp m,OA3a                       ;
                ld (ix),d                       ;
OA3a            pop ix                          ;
                ret                             ;

OA3             add a,c                         ;
                ld l,a                          ;
                ex af,af'                       ;
                exx                             ;
                call Incxx                      ;
OAxx            equ .-2                         ;
                call Incxx                      ;
OAyy            equ .-2                         ;
                ld (hl),a                       ;
                djnz OA1                        ;
                jp OA3x                         ;

AnyLine         call ClipThing                  ;
                ccf                             ;
                ret nc                          ;

                ld a,(ctX1)                     ;
                ld e,a                          ;
                srl e                           ;
                srl e                           ;
                srl e                           ;
                and $07                         ;
                ld l,a                          ;
                ld h,BitTab/256                 ;
                ld c,(hl)                       ;
                ld h,DivTab/256                 ;
                ld a,(ctY1)                     ;
                ld l,a                          ;
                ld a,(hl)                       ;
                ld (ctY1),a                     ;
                ld d,a                          ;
                rlca                            ;
                rlca                            ;
                and $03                         ;
                or $58                          ;
                ld (IX_h),a                     ;
                ld (iy+dLineIX+1),a             ;
                ld a,d                          ;
                rlca                            ;
                rlca                            ;
                and $E0                         ;
                or e                            ;
                ld (IX_l),a                     ;
                ld (iy+dLineIX),a               ;
                ld a,(ctY2)                     ;
                ld l,a                          ;
                ld a,(hl)                       ;
                ld (ctY2),a                     ;
                ld a,d                          ;
                and $07                         ;
                ld l,a                          ;
                ld h,BitTab/256                 ;
                ld b,(hl)                       ;
                exx                             ;
                push ix                         ;
                push iy                         ;
                ld iy,Incyy                     ;
                ld ix,Incxx                     ;
                ld de,(ctY1)                    ;
                ld hl,(ctY2)                    ;
                or a                            ;
                sbc hl,de                       ;
                jp p,LineA                      ;
                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                inc hl                          ;
                ld iy,Decyy                     ;
LineA           ld c,l                          ;
                ld b,h                          ;
                ld de,(ctX1)                    ;
                ld hl,(ctX2)                    ;
                or a                            ;
                sbc hl,de                       ;
                jp p,LineB                      ;
                ld a,l                          ;
                cpl                             ;
                ld l,a                          ;
                ld a,h                          ;
                cpl                             ;
                ld h,a                          ;
                inc hl                          ;
                ld ix,Decxx                     ;
LineB           ld (sxxVector),ix               ;
                ld (syyVector),iy               ;
                or a                            ;
                sbc hl,bc                       ;
                add hl,bc                       ;
                jp m,LineC                      ;
                ld (HorizVector),ix             ;
                ld e,c                          ;
                ld d,b                          ;
                ld c,l                          ;
                ld b,h                          ;
                jp LineD                        ;

LineC           ld (HorizVector),iy             ;
                ld e,l                          ;
                ld d,h                          ;
                ld l,c                          ;
                ld h,b                          ;
LineD           sra h                           ;
                rr l                            ;
                ld a,c                          ;
                exx                             ;
                pop iy                          ;
                pop ix                          ;
                scf                             ;
                ccf                             ;
                ret z                           ;
                ex af,af'                       ;
                ld h,YTable/256                 ;
                ld l,d                          ;
                ld a,(hl)                       ;
                add a,e                         ;
                inc h                           ;
                ld h,(hl)                       ;
                ld l,a                          ;
                ex af,af'                       ;
                ld e,b                          ;
                ld b,a                          ;
                ld (iy+dpLineAlg),ALOld & $FF   ;
                ld (iy+dpLineAlg+1),ALOld / 256 ;
                ld (iy+dLineL),l                ;
                ld (iy+dLineH),h                ;
                ld (iy+dLineE),e                ;
                ld (iy+dLineC),c                ;
                ld (iy+dLineB),b                ;
                exx                             ;
                ld (iy+dLineL1),l               ;
                ld (iy+dLineE1),e               ;
                ld (iy+dLineC1),c               ;
                exx                             ;
                ld a,(Colour)                   ;
                ld d,a                          ;
                push ix                         ;
                ld ix,$0000                     ;
IX_l            equ .-2                         ;
IX_h            equ .-1                         ;
                ld a,(hl)                       ;
LineAlg         or c                            ;
                exx                             ;
                ex af,af'                       ;
                ld a,l                          ;
                sub e                           ;
                jr c,LineAlg1                   ;
                ld l,a                          ;
                exx                             ;
                ex af,af'                       ;
                call Ret02                      ;
HorizVector     equ .-2                         ;
                djnz LineAlg                    ;
                jp LineX                        ;

LineAlg1        add a,c                         ;
                ld l,a                          ;
                exx                             ;
                ex af,af'                       ;
                call Ret02                      ;
sxxVector       equ .-2                         ;
                call Ret02                      ;
syyVector       equ .-2                         ;
                djnz LineAlg                    ;
LineX           ld (hl),a                       ;
                ld a,e                          ;
                and c                           ;
                jp m,LineXa                     ;
                ld (ix),d                       ;
LineXa          pop ix                          ;
                ld a,(sxxVector)                ;
                ld (iy+dLineSxx),a              ;
                ld a,(syyVector)                ;
                ld (iy+dLineSyy),a              ;
                ld a,(HorizVector)              ;
                ld (iy+dLineHV),a               ;

                set bOnScreen,(ix+dObjeFlags)   ;

                scf                             ;
                ret                             ;

;  Align to a page boundary

                align 256                       ;

Incxx           rrc c                           ;
                ret nc                          ;
                ld (hl),a                       ;
                ld (ix),d                       ;
                inc ixl                         ;
                inc l                           ;

                ld a,r                          ;
                and $F8                         ;
SoundFlagAL     equ .-1                         ;

                out (SoundPort),a               ;

                ld a,(hl)                       ;
                ret                             ;

Decxx           rlc c                           ;
                ret nc                          ;
                ld (hl),a                       ;
                ld (ix),d                       ;
                dec ixl                         ;
                dec l                           ;

                ld a,r                          ;
                and $F8                         ;
SoundFlagAL1    equ .-1                         ;

                out (SoundPort),a               ;

                ld a,(hl)                       ;
                ret                             ;

Incyy           ld (hl),a                       ;
                inc h                           ;
                rrc e                           ;
                ld a,(hl)                       ;
                ret nc                          ;
                ld (ix),d                       ;
                push bc                         ;
                ld bc,$20                       ;
                add ix,bc                       ;
                pop bc                          ;
                ld a,l                          ;
                add a,$20                       ;
                ld l,a                          ;
                ld a,(hl)                       ;
                ret c                           ;
                ld a,h                          ;
                sub $08                         ;
                ld h,a                          ;
                ld a,(hl)                       ;
                ret                             ;

Decyy           ld (hl),a                       ;
                dec h                           ;
                rlc e                           ;
                ld a,(hl)                       ;
                ret nc                          ;
                ld (ix),d                       ;
                push bc                         ;
                ld bc,-$20                      ;
                add ix,bc                       ;
                pop bc                          ;
                ld a,l                          ;
                sub $20                         ;
                ld l,a                          ;
                ld a,(hl)                       ;
                ret c                           ;
                ld a,h                          ;
                add a,$08                       ;
                ld h,a                          ;
                ld a,(hl)                       ;
                ret                             ;

MinX            defs 2                          ;
nMinX           defs 2                          ;
MaxX            defs 2                          ;

TopY            defs 2                          ;
nTopY           defs 2                          ;
BotY            defs 2                          ;

AMinX           defs 2                          ;
AMaxX           defs 2                          ;
ATopY           defs 2                          ;
ABotY           defs 2                          ;

pFreeObje       defs 2                          ;

cObjeZ          defs 2                          ;

ObjeSeq         defs nObjes*4*2                 ;

pFreeLines      defs 2                          ;

        if enabled bFrameLock
cSecCount       defs 1                          ;
        endif

;  End of SUBS
